/*
	音频播放
*/
Plug.audio={
	func:'',
	audio:'',
	namepre:'audio',
	playtype:'one',
	status:false,
	item:{},
	init:function(item,func){
		if(typeof(item)!='object') return false;
		this.func=func;
		if(this.audio)
		{
			if(item.playtype) this.playtype=item.playtype;
			if(item.progress) this.progress.init(this.namepre,this.audio);
			this.set(item);
			this.back({eventType:'reset'});
		}
		else
		{
			this.playtype=item.playtype || 'one';
			this.show(item,func);
			if(item.progress) this.progress.init(this.namepre,this.audio);
			this.set(item);
			this.back({eventType:'success'});
		}
	},
	set:function(item){
		var title=item.title || '';
		$('.'+this.namepre+'info').html(title);
		this.item=item;
		this.reset();
	},
	reset:function(){
		this.audio.src=this.item.url;
		this.audio.play();
	},
	show:function(item,func){
		
		var id=item.id;
		var bgcolor='rgba(0,0,0,0.5)';
		var bordercolor='#fff';
		
		var namepre='audio';
		this.namepre=namepre;
		
		var css='';
		css+='#'+id+'{background:rgba(0,0,0,0.8);}';
		
		css+='#'+id+' .'+namepre+'box2{}';
		css+='#'+id+' .'+namepre+'info{margin:16px 0px;padding:0px 16px;clear:both;text-align:center;color:#fff;font-size:18px;}';
		
		css+='#'+id+' .'+namepre+'playbox{height:40px;padding:15px 16px 15px 16px;overflow:hidden;}';
		css+='#'+id+' .'+namepre+'start{position:relative;width:40px;height:30px;margin:0px 20px;}';
		css+='#'+id+' .'+namepre+'start:before{content:"";width:0;height:0;border-width:14px 0 14px 22px;border-style:solid;border-color:transparent transparent transparent '+bordercolor+';position:absolute;top:2px;left:10px;border-radius:1px;}';
		
		css+='#'+id+' .'+namepre+'pause{position:relative;width:40px;height:30px;margin:0px 20px;}';
		css+='#'+id+' .'+namepre+'pause:before{position:absolute;content:"";width:5px;height:30px;background:'+bordercolor+';border-radius:5px;left:10px;}';
		css+='#'+id+' .'+namepre+'pause:after{position:absolute;content:"";width:5px;height:30px;background:'+bordercolor+';border-radius:5px;right:10px;}';
		
		css+='#'+id+' .'+namepre+'pre{position:relative;width:40px;height:16px;margin-top:8px;}';
		css+='#'+id+' .'+namepre+'pre:before,#'+id+' .'+namepre+'pre:after{content:"";width:0;height:0;border-width:7px 11px 7px 0px;border-style:solid;border-color:transparent '+bordercolor+' transparent transparent;position:absolute;border-radius:1px;}';
		css+='#'+id+' .'+namepre+'pre:before{top:2px;right:3px;}';
		css+='#'+id+' .'+namepre+'pre:after{top:2px;right:13px;}';
		
		css+='#'+id+' .'+namepre+'next{position:relative;width:40px;height:16px;margin-top:8px;}';
		css+='#'+id+' .'+namepre+'next:before,#'+id+' .'+namepre+'next:after{content:"";width:0;height:0;border-width:7px 0 7px 11px;border-style:solid;border-color:transparent transparent transparent '+bordercolor+';position:absolute;border-radius:1px;}';
		css+='#'+id+' .'+namepre+'next:before{top:2px;left:3px;}';
		css+='#'+id+' .'+namepre+'next:after{top:2px;left:13px;}';
		
		var lopcolor=bordercolor;
		
		css+='#'+id+' .'+namepre+'loop{width:18px;height:11px;margin-top:10px;position:relative;}';
		css+='#'+id+' .'+namepre+'loop .'+namepre+'loopson{position:absolute;content:"";width:13px;height:9px;}';
		css+='#'+id+' .'+namepre+'loop .'+namepre+'loopa{right:0px;top:0px;border:solid '+lopcolor+';border-radius:1.5px;border-width:0.5px 0.5px 0px 0px;}';
		css+='#'+id+' .'+namepre+'loop .'+namepre+'loopa:after{position:absolute;content:"";width:3px;height:3px;border:solid '+lopcolor+';border-width:0.5px 0.5px 0px 0px;-webkit-transform: rotate(135deg);right:-2px;bottom:0px;}';
		css+='#'+id+' .'+namepre+'loop .'+namepre+'loopb{left:0px;bottom:0px;border:solid '+lopcolor+';border-radius:1.5px;border-width:0px 0px 0.5px 0.5px;}';
		css+='#'+id+' .'+namepre+'loop .'+namepre+'loopb:after{position:absolute;content:"";width:3px;height:3px;border:solid '+lopcolor+';border-width:0px 0px 0.5px 0.5px;-webkit-transform: rotate(135deg);left:-2px;top:0px;}';
		
		css+='#'+id+' .'+namepre+'one{width:18px;height:11px;margin-top:10px;position:relative;border:solid '+lopcolor+';border-radius:1.5px;border-width:1px 1px 1px 0px;}';
		css+='#'+id+' .'+namepre+'one:after{position:absolute;content:"";width:3px;height:3px;border:solid '+lopcolor+';border-width:0px 1px 1px 0px;-webkit-transform: rotate(135deg);left:0px;bottom:-2px;}';
		
		css+='#'+id+' .'+namepre+'oneloop{width:18px;height:11px;margin-top:10px;position:relative;border:solid '+lopcolor+';border-radius:1.5px;border-width:0px 0px 1px 1px;}';
		css+='#'+id+' .'+namepre+'oneloop:after{position:absolute;content:"";width:3px;height:3px;border:solid '+lopcolor+';border-width:0px 0px 1px 1px;-webkit-transform: rotate(135deg);left:-2.5px;top:0px;}';
		
		css+='#'+id+' .'+namepre+'oneloop .'+namepre+'oneloopa{position:absolute;content:"";width:13px;height:10px;border:solid '+lopcolor+';border-radius:1.5px;border-width:1px 1px 0px 0px;right:0px;bottom:0px;}';
		
		css+='#'+id+' .'+namepre+'again{width:14px;height:14px;margin-top:10px;position:relative;border:solid '+lopcolor+';border-radius:50%;border-width:1.5px 1.5px 1.5px 0px;}';
		
		css+='#'+id+' .'+namepre+'again:after{position:absolute;content:"";width:3px;height:3px;border:solid '+lopcolor+';border-width:0px 0px 1px 1px;-webkit-transform: rotate(105deg);left:-1px;top:9px;}';
		
		css+='#'+id+' .'+namepre+'pgbox{padding:30px 0px 0px 0px;}';
		css+='#'+id+' .'+namepre+'pgrun{height:16px;position:relative;}';
		css+='#'+id+' .'+namepre+'pgall{height:1px;background:rgba(255,255,255,0.8);top:8px;position:absolute;width:100%;}';
		css+='#'+id+' .'+namepre+'pgplaying{top:5px;position:absolute;}';
		css+='#'+id+' .'+namepre+'pgline{height:1px;background:rgba(255,0,0,1);margin-top:3px;}';
		css+='#'+id+' .'+namepre+'pgpoint{background:#ddd;border:1.5px solid #f00;width:3px;height:3px;margin-top:1px;border-radius:50%;}';
		css+='#'+id+' .'+namepre+'currenttime,#'+id+' .'+namepre+'duration{color:rgba(255,255,255,0.8);line-height:16px;height:16px;font-size:12px;margin:0px 12px;}';
		
		if(document.all)
		{ // document.createStyleSheet(url)
			window.style=css; 
			document.createStyleSheet("javascript:style"); 
		}
		else
		{ 	//document.createElement(style)
			var style = document.createElement('style'); 
			style.type = 'text/css'; 
			style.innerHTML=css; 
			document.getElementsByTagName('HEAD').item(0).appendChild(style); 
		}
		
		var str='';
		str+='';
		str+='<div class="'+namepre+'box2">';
		str+='<div style="height:40px;"></div>';
		str+='<div class="'+namepre+'info"></div>';
		

		str+='<div class="flex_row '+namepre+'playbox">';
			str+='<div class="'+namepre+'playtype '+namepre+this.playtype+'"><div class="'+namepre+'loopson '+namepre+'loopa"></div><div class="'+namepre+'loopson '+namepre+'loopb"></div><div class="'+namepre+'oneloopa"></div></div>';
			str+='<div class="flex_son"></div>';
			str+='<div class="'+namepre+'pre"></div>';
			str+='<div class="'+namepre+'play '+namepre+'pause"></div>';
			str+='<div class="'+namepre+'next"></div>';
			str+='<div class="flex_son"></div>';
			str+='<div class="'+namepre+'again"></div>';
		str+='</div>';
		
		str+='<div id="'+namepre+'progress"></div>';
		str+='<div style="clear:both;height:10px;"></div>';
		str+='</div>';
		$('#'+id).html(str);
		
		var self=this;

		this.audio = document.createElement("AUDIO");
		
		var msg='';
		
		/*
		//当发生中止事件时运行脚本
		this.audio.onabort=function(){
			alert('onabort');
		}
		*/
		
		//当媒介能够开始播放但可能因缓冲而需要停止时运行脚本
		this.audio.oncanplay=function(){
			self.status='canplay';
			self.progress.run();
		}
		
		/*
		//当媒介能够无需因缓冲而停止即可播放至结尾时运行脚本
		this.audio.oncanplaythrough=function(){
			alert('oncanplaythrough');
		}
		*/
		/*
		//当媒介长度改变时运行脚本
		this.audio.ondurationchange=function(){
			alert('ondurationchange');
		}
		*/
		
		//当媒介资源元素突然为空时（网络错误、加载错误等）运行脚本
		this.audio.onemptied=function(){
			self.status='emptied';
			msg='资源不存在';
		}
		
		//当媒介已抵达结尾时运行脚本
		this.audio.onended=function(){
			self.status='ended';
			if(self.playtype=='loop')
			{
				self.back({eventType:'next',type:'loop'});
			}
			else if(self.playtype=='oneloop')
			{
				setTimeout(function(){
					self.reset();
				},1000)
			}
			else
			{
				self.back({eventType:'end'});
			}
		}
		
		//当在元素加载期间发生错误时运行脚本
		this.audio.onerror=function(){
			self.status='error';
			if(!msg) msg='未知错误';
			api.alert({msg:msg,location:'top'});
		}
		
		/*
		//当加载媒介数据时运行脚本
		this.audio.onloadeddata=function(){
			alert('onloadeddata');
		}
		*/
		/*
		//当媒介元素的持续时间以及其他媒介数据已加载时运行脚本
		this.audio.onloadedmetadata=function(){
			alert('onloadedmetadata');
		}
		*/
		/*
		//当浏览器开始加载媒介数据时运行脚本
		this.audio.onloadstart=function(){
			alert('onloadstart');
		}
		*/
		
		//当媒介数据暂停时运行脚本
		this.audio.onpause=function(){
			self.status='pause';
			$('.'+namepre+'play').removeClass(namepre+'pause');
			$('.'+namepre+'play').addClass(namepre+'start');
			self.back({eventType:'pause'});
		}
		
		//当媒介数据将要开始播放时运行脚本
		this.audio.onplay=function(){
			self.status='play';
			$('.'+namepre+'play').removeClass(namepre+'start');
			$('.'+namepre+'play').addClass(namepre+'pause');
			self.back({eventType:'start'});
		}
		
		/*
		//当媒介数据已开始播放时运行脚本
		this.audio.onplaying=function(ret){
			api.toast({msg:JSON.stringify(ret)});
		}
		*/
		/*
		//当浏览器正在取媒介数据时运行脚本
		this.audio.onprogress=function(ret){
			api.toast({msg:'onprogress'+JSON.stringify(ret)});
		}
		*/
		/*
		//当媒介数据的播放速率改变时运行脚本
		this.audio.onratechange=function(ret){
			api.toast({msg:'onratechange'+JSON.stringify(ret)});
		}
		*/
		/*
		//当就绪状态（ready-state）改变时运行脚本
		this.audio.onreadystatechange=function(ret){
			api.toast({msg:ret});
		}
		*/
		/*
		//当媒介元素的定位属性 [1] 不再为真且定位已结束时运行脚本
		this.audio.onseeked=function(ret){
			api.toast({msg:'onseeked'+JSON.stringify(ret)});
		}
		*/
		/*
		//当媒介元素的定位属性为真且定位已开始时运行脚本
		this.audio.onseeking=function(ret){
			api.toast({msg:'onseeking'+JSON.stringify(ret)});
		}
		*/
		/*
		//当取回媒介数据过程中（延迟）存在错误时运行脚本
		this.audio.onstalled=function(ret){
			api.toast({msg:'onstalled'+JSON.stringify(ret)});
		}
		*/
		/*
		//当浏览器已在取媒介数据但在取回整个媒介文件之前停止时运行脚本
		this.audio.onsuspend=function(ret){
			api.toast({msg:'onsuspend'+JSON.stringify(ret)});
		}
		*/
		//当媒介改变其播放位置时运行脚本
		this.audio.ontimeupdate=function(ret){
			self.status='play';
			self.progress.run();
		}
		
		/*
		//当媒介改变音量亦或当音量被设置为静音时运行脚本
		this.audio.onvolumechange=function(ret){
			api.toast({msg:'onvolumechange'+JSON.stringify(ret)});
		}
		*/
		/*
		//当媒介已停止播放但打算继续播放时运行脚本
		this.audio.onwaiting=function(ret){
			api.toast({msg:'onwaiting'+JSON.stringify(ret)});
		}
		$('#'+id).append(this.audio);
		*/
		
		//播放或暂停
		$('#'+id+' .'+namepre+'play').click(function(){
			if(self.status=='pause')
			{
				self.audio.play();
			}
			else if(self.status=='play')
			{
				self.audio.pause();
			}
			else if(self.status=='ended')
			{
				self.reset();
			}
		})
		
		//上一条
		$('#'+id+' .'+namepre+'pre').click(function(){
			self.back({eventType:'pre'});
		})
		
		//下一条
		$('#'+id+' .'+namepre+'next').click(function(){
			self.back({eventType:'next'});
		})
		
		//播放类型
		$('#'+id+' .'+namepre+'playtype').click(function(){
			//循环播放
			if($(this).hasClass(namepre+'loop'))
			{
				$(this).removeClass(namepre+'loop');
				$(this).addClass(namepre+'one');
				self.playtype='one';
				api.toast({msg:'单个播放',location:'top'});
			}
			else if($(this).hasClass(namepre+'one'))
			{
				$(this).removeClass(namepre+'one');
				$(this).addClass(namepre+'oneloop');
				self.playtype='oneloop';
				api.toast({msg:'单个循环',location:'top'});
			}
			else if($(this).hasClass(namepre+'oneloop'))
			{
				$(this).removeClass(namepre+'oneloop');
				$(this).addClass(namepre+'loop');
				self.playtype='loop';
				api.toast({msg:'循环播放',location:'top'});
			}
		})
		
		//重新播放
		$('#'+id+' .'+namepre+'again').click(function(){
			if(self.playtype=='loop')
			{
				self.back({eventType:'again'});
			}
			else
			{
				self.reset();
			}
		})
	},
	back:function(ret){
		this.func && this.func(ret);
	},
	//进度条
	progress:{
		isopen:false,
		istouch:false,
		namepre:'',
		audio:'',
		init:function(namepre,audio){
			this.isopen=true;
			this.namepre=namepre;
			this.audio=audio;
			
			var str='';
			str+='<div class="flex_row '+namepre+'pgbox">';
				str+='<div class="'+namepre+'currenttime" ></div>';
				str+='<div class="flex_son">';
					str+='<div class="'+namepre+'pgrun" id="'+namepre+'pgrun">';
						str+='<div class="'+namepre+'pgall"></div>';
						str+='<div class="'+namepre+'pgplaying flex_row">';
							str+='<div class="'+namepre+'pgline"></div>';
							str+='<div class="'+namepre+'pgpoint"></div>';
							str+='<div class="flex_son"></div>';
						str+='</div>';
					str+='</div>';
				str+='</div>';
				str+='<div class="'+namepre+'duration"></div>';
			str+='</div>';
			$('#'+namepre+'progress').html(str)
			
			var self=this;
			var progressbox=document.getElementById(namepre+'pgrun');
			//开始
			progressbox.ontouchstart=function(ev){
				ev.preventDefault();
				self.istouch=true;
				var dis=ev.targetTouches[0].clientX-$(this).offset().left;
				$('.'+namepre+'pgline').width(dis);
			}
			//移动
			progressbox.ontouchmove=function(ev){
				var dis=ev.targetTouches[0].clientX-$(this).offset().left;
				$('.'+namepre+'pgline').width(dis);
			}
			
			progressbox.ontouchend=function(ev){
				ev.returnValue = true;
				var l=$(this).width();
				var dis=$('.'+namepre+'pgline').width();
				var duration=self.audio.duration || 0;
				if(duration > 0)
				{
					var seconds=duration * dis / l;
					self.audio.currentTime=seconds;
				}
				self.istouch=false;
			}
		},
		run:function(){
			if(this.isopen==false) return;
			if(this.istouch) return;
			//音频长度
			var duration=this.audio.duration || 0;
			//当前时间
			var currentTime=this.audio.currentTime || 0;
			
			if(duration)
			{
				if(currentTime)
				{
					var _left=$('.'+this.namepre+'pgrun').width() * currentTime / duration;
				}
				else
				{
					var _left=0;
				}
				$('.'+this.namepre+'pgline').width(_left);
				$('.'+this.namepre+'currenttime').html(this.getTime(currentTime));
				$('.'+this.namepre+'duration').html(this.getTime(duration));
			}
			else
			{
				$('.'+this.namepre+'pgline').width(0);
				$('.'+this.namepre+'currenttime').html('');
				$('.'+this.namepre+'duration').html('');
			}
		},
		getTime:function(duration){
			var str='';
			var m=Math.round(duration / 60);
			if(m)
			{
				if(m>60)
				{
					var h=Math.round(m / 60);
					if(h<10) h='0'+h;
					str+=h+':';
					var m=Math.round(m % 60);
				}
				if(m<10) m='0'+m;
				str+=m+':';
			}
			else
			{
				str+='00:';
			}
			
			var s=Math.round(duration % 60);
			if(s<10) s='0'+s;
			str+=s;
			return str;
		}		
	}
}