//英语
Plug.english={
	module:'english',
	url:'https://kc.xuezizhai.com/app.php?s=80&module=english',
	/*
	请求服务器获取数据
	item 请求参数
	func 回调函数
	*/
	getData:function(item,func,post){
		var url=this.url;
		getmData(item,func,post,url);
	},
	/*
		单词朗读
	*/
	bookword:{
		istable:0,
		table:'english_bookword',
		items:{},
		//打开我的收藏
		open:function(aid){
			this.get(aid,function(ret){
				if(ret.status)
				{
					App.Win.open({name:Plug.english.module+'/bookword',aid:aid,pageParam:ret.data});
				}
				else
				{
					api.alert({msg:ret.data});
				}
			})
		},
		//分享
		share:function(aid,type,func){
			var self=this;
			var item={view:'article',cm:'getshare',aid:aid};
			Plug.english.getData(item,function(ret,err){
				if(ret)
				{
					if(ret.status==3)
					{
						Plug.open('share',function(){
							Plug.share.send(ret.data,type,function(ret){
								func && func(ret);
							})
						})
					}
					else
					{
						func && func({status:false,data:ret.data});
					}
				}
				else
				{
					func && func({status:false,data:err.msg});
				}
			})
		},
		//获取内容
		get:function(aid,func){
			var self=this;
			//获取服务器数据
			var remote=function(){
				var para={view:'bookword',cm:'getitem',aid:aid};
				Plug.english.getData(para,function(ret,err){
					if(ret)
					{
						func && func(ret);
						if(ret.status==3)
						{
							var item=ret.data;
							self.add(item,true);
						}
					}
					else
					{
						func && func(ret,err);
					}
				})
			}
			var item=this.getItem(aid);
			//缓存 存在
			if(item)
			{
				var date=new Date();
				var nowtime=date.getStamp();
				if(nowtime>item.cachetime)
				{
					remote();
				}
				else
				{
					func && func({status:3,data:item});
					this.add(item);
				}
			}
			else //缓存不存在 请求服务器数据
			{
				remote();
			}
		},
		//查询数据
		getItem:function(aid){
			if(this.items[aid]) return this.items[aid];
			
			var table=this.getTable();
			//不支持缓存
			if(!table) return false;
			var param={};
			param.where=[];
			param.where='aid ='+aid;
			
			var ret=Db.getItem(table,param);
			if(ret.status)
			{
				var item=JSON.parse(ret.data.body);
				item.cachetime=ret.data.cachetime;
				this.items[aid]=item;
				return item;
			}
			else
			{
				return false;
			}
		},
		//查询数据
		getLists:function(start){
			var table=this.getTable();
			//不支持缓存
			if(!table) return false;
			var param={};
			param.offset=start || 0;
			param.limit=20;
			param.order='edittime DESC';
			var ret=Db.getLists(table,param);
			if(ret.status)
			{
				var lists=[];
				for(var i=0;i<ret.data.length;i++)
				{
					lists.push(JSON.parse(ret.data[i].body));
				}
				return lists;
			}
			else
			{
				return false;
			}
		},
		//添加
		add:function(item,isnew){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};

			var post={};
			post.aid=item.aid;
			var date=new Date();
			var nowtime=date.getStamp();
			post.edittime=nowtime;
			
			if(isnew)
			{
				var cachetime=item.cachetime || 10*60;
				post.cachetime=cachetime+nowtime;
				item.cachetime=post.cachetime
			}
			post.body=JSON.stringify(item);
			var aid=item.aid;
			
			var ret=this.getItem(aid);
			if(ret)
			{
				var ret=Db.update(table,post,'aid='+aid);
			}
			else
			{
				var ret=Db.insert(table,post);
			}
			this.items[aid]=item;
			return ret;
		},
		del:function(aid){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};
			return Db.update(table,'aid='+aid);
		},
		drop:function(){
			var ret=Db.drop(this.table);
			api.alert({msg:ret});
		},
		getTable:function(){
			if(this.istable) return this.table;
			
			var ret=Db.isTable(this.table);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			var field='aid int PRIMARY KEY,edittime int,cachetime int,title varchar(255),body TEXT';
			var ret=Db.create(this.table,field);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			return false;
		}
	}
}