/*
	图片
*/
Plug.image={
	/**图片缓存
	 *  
	 */
	cache:{
		/**容器内容图片缓存
		 *  
		 * @access    public 
		 * @param     string  id  容器
		 * @return    bool
		 */
		container:function(obj,thumbnail,func){
			var self=this;
			$(obj).find('img[data_src]').each(function(){
				self.load(this,thumbnail,func);
			})
		},
		/**载入图片
		 *  
		 * @access    public 
		 * @param     object  obj 容器
		 * @param     bool  thumbnail 是否使用缩略图 默认 true
		 * @return    null
		 */
		load:function(obj,thumbnail,func){
			if(typeof(thumbnail)=='undefined') thumbnail=true;
			var url=$(obj).attr('data_src');
			//图片地址不存在
			if(!url)
			{
				func && func({status:false,msg:'图片地址不存在'});
				return ;
			}
			
			/**图片地址转64位图片格式
			 *  
			 * @access    public 
			 * @param     object  obj 容器
			 * @param     bool  thumbnail 是否使用缩略图 默认 true
			 * @return    null
			 */
			var base64=function(path){
				var type=Plug.image.type(path);
				
				var fs = api.require('fs');
				var ret = fs.existSync({
					path: path
				});
				if(ret.exist==false) return;
				var trans = api.require('trans');
				trans.decodeImgToBase64({
					imgPath:path
				}, function(ret, err){
					if (ret.status)
					{
						var str='data:'+type+';base64,'+ret.base64Str;
						$(obj).attr('src',str);
					}
					else
					{
						Log.system(path+'图片转64位失败 trans.decodeImgToBase64 '+JSON.stringify(err),6);
					}
				});
			}
			
			var reg=/(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/;
			if(!reg.test(url))
			{
				base64(url);
				return;
			}
			
			//移除data_src属性
			$(obj).removeAttr('data_src');
			var self=this;
			$(obj).attr('src',url);
			return;
			api.imageCache({
				url:url,
				thumbnail:thumbnail
			}, function(ret, err){
				if(ret.status)
				{
					base64(ret.url);
				}
				//缓存图片失败
				else
				{
					$(obj).attr('src',url);
					Log.system(url+'图片缓存失败api.imageCache '+JSON.stringify(err),6);
				}
			});
		}
	},
	/**获取图片类型
	 *  
	 * @access    public 
	 * @param     url  地址
	 * @return    string
	 */
	type:function(url){//初始化
		var imgtype = url.toLowerCase().split('.');
		var ext=imgtype[imgtype.length-1];
		ext=ext.replace(/^(jpg|gif|png|jpeg|bmp).*/g,'$1');
		switch(ext)
		{
			case 'jpg':
			var type='image/jpg';
			break;
			case 'gif':
			var type='image/gif';
			break;
			case 'png':
				var type='image/png';
			break;
			default:
				var type='image/jpeg';
			break;
		}
		return type;
	}
}