//视频课程
Plug.kc={
	module:'kc',
	url:'https://kc.xuezizhai.com/app.php?s=80&module=kc',
	/*
	请求服务器获取数据
	item 请求参数
	func 回调函数
	*/
	getData:function(item,func,post){
		var url=this.url;
		getmData(item,func,post,url);
	},
	/*
		打开内容
	*/
	article:{
		istable:0,
		table:'kc2_article',
		items:{},
		//打开我的收藏
		open:function(aid){
			this.get(aid,function(ret){
				if(ret.status)
				{
					switch(parseInt(ret.data.cat))
					{
						//课程
						case 1:
							var cat=ret.data.cat;
							App.Win.open({name:Plug.kc.module+'/article_'+cat,aid:aid,pageParam:ret.data});
						break;
						//题库
						case 3:
							var url='https://kc.xuezizhai.com/app.php?s=80&module=question&view=book&cm=view&aid='+ret.data.fromid;
							App.Win.open({name:'mall/url',pageParam:{url:url}});
							return;
							break;
						//单词
						case 5:
							var url='http://kc.xuezizhai.com/app.php?s=80&module=english&view=book&cm=view&aid='+ret.data.bookword;
							var param={name:'index/url'};
							param.pageParam={url:url};
							App.Win.open(param);
						break;
						default:
							alert('未开放');
						break;
					}
				}
				else
				{
					api.alert({msg:ret.data});
				}
			})
		},
		//分享
		share:function(aid,type,func){
			var self=this;
			var item={view:'article',cm:'getshare',aid:aid};
			Plug.kc.getData(item,function(ret,err){
				if(ret)
				{
					if(ret.status==3)
					{
						Plug.open('share',function(){
							Plug.share.send(ret.data,type,function(ret){
								func && func(ret);
							})
						})
					}
					else
					{
						func && func({status:false,data:ret.data});
					}
				}
				else
				{
					func && func({status:false,data:err.msg});
				}
			})
		},
		//获取内容
		get:function(aid,func){
			var self=this;
			//获取服务器数据
			var remote=function(){
				var para={view:'article',cm:'getitem',aid:aid};
				Plug.kc.getData(para,function(ret,err){
					if(ret)
					{
						func && func(ret);
						if(ret.status==3)
						{
							var item=ret.data;
							self.add(item,true);
						}
					}
					else
					{
						func && func(ret,err);
					}
				})
			}
			var item=this.getItem(aid);
			//缓存 存在
			if(item)
			{
				var date=new Date();
				var nowtime=date.getStamp();
				if(nowtime>item.cachetime)
				{
					remote();
				}
				else
				{
					func && func({status:3,data:item});
					this.add(item);
				}
			}
			else //缓存不存在 请求服务器数据
			{
				remote();
			}
		},
		//查询数据
		getItem:function(aid){
			if(this.items[aid]) return this.items[aid];
			
			var table=this.getTable();
			//不支持缓存
			if(!table) return false;
			var param={};
			param.where=[];
			param.where='aid ='+aid;
			
			var ret=Db.getItem(table,param);
			if(ret.status)
			{
				var item=JSON.parse(ret.data.body);
				item.cachetime=ret.data.cachetime;
				this.items[aid]=item;
				return item;
			}
			else
			{
				return false;
			}
		},
		//查询数据
		getLists:function(start){
			var table=this.getTable();
			//不支持缓存
			if(!table) return false;
			var param={};
			param.offset=start || 0;
			param.limit=20;
			param.order='edittime DESC';
			var ret=Db.getLists(table,param);
			if(ret.status)
			{
				var lists=[];
				for(var i=0;i<ret.data.length;i++)
				{
					lists.push(JSON.parse(ret.data[i].body));
				}
				return lists;
			}
			else
			{
				return false;
			}
		},
		//添加
		add:function(item,isnew){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};

			var post={};
			post.aid=item.aid;
			var date=new Date();
			var nowtime=date.getStamp();
			post.edittime=nowtime;
			
			if(isnew)
			{
				var cachetime=item.cachetime || 10*60;
				post.cachetime=cachetime+nowtime;
				item.cachetime=post.cachetime
			}
			post.body=JSON.stringify(item);
			var aid=item.aid;
			
			var ret=this.getItem(aid);
			if(ret)
			{
				var ret=Db.update(table,post,'aid='+aid);
			}
			else
			{
				var ret=Db.insert(table,post);
			}
			this.items[aid]=item;
			return ret;
		},
		del:function(aid){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};
			return Db.update(table,'aid='+aid);
		},
		drop:function(){
			var ret=Db.drop(this.table);
			api.alert({msg:ret});
		},
		getTable:function(){
			if(this.istable) return this.table;
			
			var ret=Db.isTable(this.table);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			var field='aid int PRIMARY KEY,edittime int,cachetime int,title varchar(255),body TEXT';
			var ret=Db.create(this.table,field);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			return false;
		}
	},
	//收藏
	stow:{
		istable:false,
		table:'kc_article_stow',
		item:{start:0},
		cacheover:0,//缓存数据是否完毕
		remoteover:0,//远程数据是否完毕
		//打开我的收藏
		open:function(){
			App.Win.open({name:Plug.kc.module+'/stow'});
		},
		//发送收藏申请
		send:function(article,func,isstow){
			var self=this;
			var item ={view:'stow',article:article,cm:'send',isstow:isstow};
			Plug.kc.getData(item,function(ret,err){
				if(ret)
				{
					//收藏成功 更新缓存
					if(ret.status==3)
					{
						var re=self.add(ret.data);
						var jsfun = 'D.stow()';
						//更新首页收藏
						SetConfig.execScript(jsfun);
					}
					//取消收藏 更新缓存
					else if(ret.status==2)
					{
						var re=self.del(article,ret.data.mid);
						var jsfun = 'D.stow()';
						//更新首页收藏
						SetConfig.execScript(jsfun);
					}
				}
				else
				{
					ret={status:1,data:err.msg};
				}
				func && func(ret);

			});
		},
		//查询数据
		get:function(mid,func){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};
			
			var param={};
			param.where=[];
			param.where.push('mid ='+mid);
			var ret=Db.getLists(table,param);
			if(ret.status)
			{
				func && func(ret);
				return ret;
			}
			else
			{
				this.remote(func);
			}
		},
		//远程服务器
		remote:function(func){
			var param={view:'stow',cm:'getlists'};
			var self=this;
			Plug.kc.getData(param,function(ret){
				//数据返回成功
				if(ret.status==3)
				{
					if(ret.data.length>0)
					{
						for(var i=0;i<ret.data.length;i++)
						{
							var re=self.add(ret.data[i]);
						}
					}
					func && func({status:true,data:ret.data});
				}
				else
				{
					func && func({status:false,data:ret.data});
				}
			})
		},
		//添加收藏
		add:function(item){
			if(!item.title) return {status:false,msg:'标题不存在'};
			if(!item.article) return {status:false,msg:'内容不存在'};
			if(!item.mid) return {status:false,msg:'用户不存在'};
			
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};
			
			var post={};
			post.aid=item.aid;
			post.title=item.title || '';
			post.article=item.article || 0;
			post.mid=item.mid || 0;
			post.addtime=item.addtime || 0;
			post.litpic=item.litpic || '';

			if(this.check(item.article,item.mid))
			{
				var sqlw=[];
				sqlw.push('article='+item.article);
				sqlw.push('mid='+item.mid);
				var ret=Db.update(table,post,sqlw);
			}
			else
			{
				var ret=Db.insert(table,post);
			}
			return ret;
		},
		//删除收藏
		del:function(article,mid){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};

			var sqlw=[];
			sqlw.push('article='+article);
			sqlw.push('mid='+mid);
			var ret=Db.delete(table,sqlw);
			return ret;
		},
		//检测是否收藏
		check:function(article,mid){
			if(!article) return false;
			if(!mid) return false;
	
			var table=this.getTable();
			//不支持缓存
			if(!table) return false;
			
			var param={};
			param.where=[];
			param.where.push('article ='+article);
			param.where.push('mid ='+mid);
			var ret=Db.getItem(table,param);
			if(ret.status)
			{
				return true;
			}
			return false;
		},
		//获取收藏表
		getTable:function(){
			if(this.istable) return this.table;
			
			var ret=Db.isTable(this.table);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			var field='aid int,mid int,article int,addtime int,checktime int, title varchar(255), litpic varchar(255), cl1name varchar(255), cl2name varchar(255), cl3name varchar(255), cl26name varchar(255)';
			var ret=Db.create(this.table,field);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			return false;
		},
		//删除表
		drop:function(){
			var ret=Db.drop(this.table);
			if(ret.status)
			{
				return true;
			}
			return false;
		}
	},
	//购买的课程
	buy:{
		istable:false,
		table:'kc_article_buy',
		item:{start:0},
		//打开
		open:function(){
			App.Win.open({name:Plug.kc.module+'/buy'});
		},
		//远程获取
		get:function(article,func){
			var param={view:'coin',cm:'check',article:article};
			var self=this;
			Plug.kc.getData(param,function(ret){
				func && func(ret);
			})
		},
		//添加收藏
		add:function(item){
			if(!item.article) return {status:false,msg:'内容不存在'};
			if(!item.mid) return {status:false,msg:'用户不存在'};
			
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};
			
			var post={};
			post.mid=item.mid;
			post.article=item.article;
			post.isbuy=item.isbuy || 0;
			
			var date=new Date();
			var nowtime=date.getStamp();
			post.edittime=nowtime;
			var cachetime=item.cachetime || 10*60;
			post.cachetime=cachetime+nowtime;
			
			var param={};
			param.where=[];
			param.where.push('article ='+post.article);
			param.where.push('mid ='+post.mid);
			
			var ret=Db.getItem(table,param);
			if(ret.status)
			{
				var ret=Db.update(table,post,param.where);
			}
			else
			{
				var ret=Db.insert(table,post);
			}
			return ret;
		},
		//删除收藏
		del:function(article,mid){
			var table=this.getTable();
			//不支持缓存
			if(!table) return {status:false,msg:'表不存在'};

			var sqlw=[];
			sqlw.push('article='+article);
			sqlw.push('mid='+mid);
			var ret=Db.delete(table,sqlw);
			return ret;
		},
		//检测是否收藏
		check:function(article,mid,func,isupdate){
			var self=this;
			var get=function(){
				self.get(article,function(ret){
					var re={};
					if(ret.status==-1)
					{
						re.status=false;
					}
					else if(ret.status==3)
					{
						re.status=true;
						self.add({article:article,mid:mid,isbuy:1});
					}
					else
					{
						self.add({article:article,mid:mid,isbuy:0});
						re.status=false;
					}
					func && func(re);
				})
			}
			
			//强制更新
			if(isupdate)
			{
				get();
				return;
			}
			
			var table=this.getTable();
			//不支持缓存
			if(!table)
			{
				get();
				return;
			}
			
			var param={};
			param.where=[];
			param.where.push('article ='+article);
			param.where.push('mid ='+mid);
			var ret=Db.getItem(table,param);
			if(ret.status)
			{
				var date=new Date();
				var nowtime=date.getStamp();
				if(nowtime>ret.data.cachetime)
				{
					get();
					return;
				}
				
				if(ret.data.isbuy)
				{
					func && func({status:true});
				}
				else
				{
					func && func({status:false});
				}
			}
			else
			{
				get();
			}
		},
		//获取收藏表
		getTable:function(){
			if(this.istable) return this.table;
			
			var ret=Db.isTable(this.table);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			var field='mid int,article int,edittime int,cachetime int,isbuy int, title varchar(255), litpic varchar(255)';
			var ret=Db.create(this.table,field);
			if(ret.status)
			{
				this.istable=1;
				return this.table;
			}
			return false;
		},
		//删除表
		drop:function(){
			var ret=Db.drop(this.table);
			if(ret.status)
			{
				return true;
			}
			return false;
		}
	},
	grade:{
		//获取视频地址 内容 id
		getmedia:function(aid,func){
			var para={view:'gradecoin',cm:'media',grade:aid};
			Plug.kc.getData(para,function(ret){
				if(!ret) ret={status:1,data:err.msg};
				func && func(ret);
			})
		}
	},
	//支付
	pay:{
		func:'',
		//打开支付窗口
		open:function(data,func){
			this.func=func;
			var para={winName:api.winName,frameName:api.frameName,func:'Plug.kc.pay.back',data:data};
			var item={name:'kc/article_pay',pageParam:para};
			item.bgColor='rgba(0 , 0, 0,0.5)';
			item.animation={type:'movein',subType:'from_bottom',duration:300};
			App.Frame.open(item);
		},
		//支付返回
		back:function(ret){
			this.func && this.func(ret);
		}
	},
	//老师
	teacher:{
		func:'',
		//打开支付窗口
		open:function(item,func){
			this.func=func;
			var self=this;
			
			var item={view:'teacher',cm:'get',cl1:item.cl1};
			Plug.kc.getData(item,function(ret,err){
				if(ret)
				{
					if(ret.status==3)
					{
						var para={winName:api.winName,frameName:api.frameName,func:'Plug.kc.teacher.back',data:ret.data};
						var item={name:'kc/article_weixin',pageParam:para};
						item.bgColor='rgba(0 , 0, 0,0.1)';
						item.animation={type:'movein',subType:'from_bottom',duration:300};
						App.Frame.open(item);
					}
					else
					{
						api.toast({msg:ret.data});
					}				
				}
				else
				{
					api.alert(err.msg);
				}
			})
		},
		//支付返回
		back:function(ret){
			this.func && this.func(ret);
		}
	},
	//关键词
	keyword:function(keyword,func){
		var param={};
		param.name=this.module+'/keyword';
		param.func=func;
		param.pageParam={keyword:keyword};
		App.Win.open(param);
	},
	//格式
	style:{
		mystow:false,
		//添加
		show:function(lists,box,func){
			var self=this;
			Plug.open('image',function(){
				for(var i=0;i<lists.length;i++)
				{
					var item=lists[i];
					var str='';
					var litpic=item.litpic || '../../image/kc_playbg.jpg';
					var title=item.cl5name || item.title;
					
					str+='<div class="item" id="item'+item.aid+'">';
						//VIP课程
						if(parseFloat(item.price)>0 && parseFloat(item.vipprice)==0)
						{
							str+='<div class="vip">VIP</div>';
						}
						else
						{
							str+='<div class="free">免费</div>';
						}
						str+='<div class="flex_row">';
							str+='<div class="litpic"  onclick="Plug.kc.article.open('+item.aid+')">';
								str+='<img class="img_load" data_src="'+litpic+'">';
							str+='</div>';
							str+='<div class="flex_son">';
								str+='<div class="flex_col">';
									str+='<div class="title"  onclick="Plug.kc.article.open('+item.aid+')">';
										str+=title;
										if(item.cl3name) str+='<span class="cl3">'+item.cl3name+'</span>';
									str+='</div>';
									str+='<div class="cl">';
										if(item.cl1name) str+='<span class="cl1">'+item.cl1name+'</span>';
										if(item.cl26name) str+='<span class="cl26">'+item.cl26name+'</span>';
										if(item.cl2name) str+='<span class="cl2">'+item.cl2name+'</span>';
									str+='</div>';
									str+='<div class="stow" id="stow'+item.aid+'" onclick="Plug.kc.style.send('+item.aid+')">';
										str+='<span class="add">加入收藏</span>';
									str+='</div>';
									str+='<div class="flex_son"></div>';
									str+='<div class="info">';
										//收藏人数
										if(item.stow)
										{
											str+='<span class="stow_num">';
												str+='<span class="sign">☆</span>';
												str+='<span class="numb">'+item.stow+'</span>';
											str+='</span>';
										}
										//浏览人数
										if(item.click)
										{
											str+='<span class="click_num">';
												str+='<div class="icon_click">';
													str+='<div class="_b _line"></div>';
													str+='<div class="_c _line"></div>';
												str+='</div>';
												str+='<span class="numb">'+item.click+'</span>';
											str+='</span>';											
										}
										//评论人数
										if(item.comment)
										{
											str+='<span class="comment_num">';
												str+='<div class="icon_comment">';
													str+='<div class="_b _line"></div>';
													str+='<div class="_c _line"></div>';
												str+='</div>';
												str+='<span class="numb">'+item.comment+'</span>';
											str+='</span>';
										}
									str+='</div>';
								str+='</div>';
							str+='</div>';
						str+='</div>';
					str+='</div>';
					box.append(str);
					//我的收藏
					if(self.mystow)
					{
						self.add(item.aid);
					}
					else
					{
						self.check(item.aid);
					}
				}
				Plug.image.cache.container(box,false);
				func && func();
			})
		},
		check:function(aid){
			var self=this;
			Plug.open('member',function(){
				Plug.member.isLogin(function(ret){
					if(ret.status)
					{
						if(Plug.kc.stow.check(aid,ret.data.mid))
						{
							self.add(aid);
						}
						else
						{
							self.del(aid);
						}
					}
					else
					{
						self.del(aid);
					}
				})
			})
		},
		send:function(aid){
			var self=this;
			var isstow=$('#stow'+aid).attr('data_isstow');
			Plug.kc.stow.send(aid,function(ret){
				//会员未登录
				if(ret.status==-1)
				{
					Plug.open('member',function(){
						Plug.member.login(function(ret){
							if(ret.eventType=='success')
							{
								self.send(aid);
							}
						})
					})
				}
				else if(ret.status==3)//收藏成功
				{
					api.confirm({
						title: '收藏成功！',
						msg: '查看我的收藏！',
						buttons: ['确定', '取消']
					}, function(ret, err)
					{
						if(ret.buttonIndex==1)
						{
							Plug.kc.stow.open();
						}
					});
					self.add(aid);
				}
				else if(ret.status==2)//取消收藏成功
				{
					api.toast({msg:'取消成功',location: 'middle'});
					self.del(aid);
				}
			},isstow)
		},
		add:function(aid){
			$('#stow'+aid).html('<span class="del" >取消收藏</span>');
			$('#stow'+aid).attr('data_isstow',0);
		},
		del:function(aid){
			if(this.mystow)
			{
				$('#item'+aid).remove();
			}
			else
			{
				$('#stow'+aid).html('<span class="add" >点击收藏</span>');
				$('#stow'+aid).attr('data_isstow',1);				
			}
		}
	}
}