/*
	视频播放
*/
Plug.media={
	/**初始化
	 *  
	 * @access    public
	 * @param     array  param 参数
	 * @return    string
	 */
	load:function(param,func){
		var id=param.id || 'video';
		var box=$('#'+id);
		var src=param.src;
		var width=box.width();
		var height=box.height();
		var self=this;
		function media(){
			//学子斋
			this.xuezizhai=function(){
				param.url=param.src;
				new Video(param,func);
			}
			//腾讯视频
			this.qq=function(vid){
				var str='<iframe frameborder="0" id="iframevideo" width="'+width+'" height="'+height+'" src="https://v.qq.com/iframe/player.html?vid='+vid+'&tiny=0&auto=0" allowfullscreen></iframe>';
				box.html(str);
				self.qrcode();
			}
			//优酷视频
			this.youku=function(vid){
				var youkujs='//player.youku.com/jsapi';
				$('#'+id).html('');
				loadScript(youkujs,function(){
					var player = new YKU.Player(id,{
					styleid: '0',
					client_id: '24340b5e3ebad4e8',
					vid: vid,
					newPlayer: true,
					autoplay: true
					});
				})
				window.addEventListener('message',function(e){
					var data = e.data;
					switch (data.msg){
						case "onPlayerStart":{
							func && func({eventType:'onStart'});
							break;
						}
						case "onPlayEnd":{
							func && func({eventType:'onEnd'});
							break;
						}
						case 'onTimeUpdate':{
							console.info(data.time);
							break;
						}
						case "state":{
						//playing或pause
						//console.info(data.stateParam);
							var state = data.stateParam;
							console.info(state);
							break;
						}
					}
				},false);
				self.qrcode();
			}
			//优酷视频
			this.aiqiy=function(){
				var str='<iframe frameborder="0" id="iframevideo" width="'+width+'" height="'+height+'" src="'+src+'" frameborder=0 allowfullscreen></iframe>';
				box.html(str);
				self.qrcode();
			}
			
			//初始化
			this.init=function(){
				var arr=src.split('/');
				//腾讯视频
				if(arr[2].indexOf('qq.com')>-1)
				{
					var vid=src.replace(/^.*vid=([^&]+).*/g,'$1');
					this.qq(vid);
				}
				//优酷视频
				else if(arr[2].indexOf('youku.com')>-1)
				{
					for(var i=3;i<arr.length;i++)
					{
						if(arr[i]=='embed')
						{
							var sid=arr[i+1];
							break;
						}
						else if(arr[i]=='sid')
						{
							var sid=arr[i+1];
							break;
						}
					}
					this.youku(sid);
				}
				//爱奇艺
				else if(arr[2].indexOf('iqiyi.com')>-1)
				{
					this.aiqiy();
				}
				//学子斋
				else if(arr[2].indexOf('xuezizhai')>-1)
				{
					this.xuezizhai();
				}
			}
			var _this=this;
			this.init();		
		}
		return new media();
	}
}


/*视频播放*/

function Video(param,func){
	var mainbox=document.getElementById(param.id);
	if(!mainbox) return;
	
	var W_width=api.winWidth;
	var W_height=api.winHeight;
	var F_width=api.frameWidth;
	var F_height=api.frameHeight;
	var F_top=W_height-F_height;
	
	var error_num=0;
	var box_width=$(mainbox).width();
	var box_height=box_width*10/16;
	$(mainbox).html('');
	
	var flex_row='display: -webkit-box;display: -webkit-flex;display: flex;';
	var flex_col='height:100%;display: -webkit-box;display: -webkit-flex;display: flex;-webkit-box-orient: vertical;-webkit-flex-flow: column;flex-flow: column;';
	var flex_son='-webkit-box-flex: 1;-webkit-flex: 1;flex:1;';
	
	var box=create('div',mainbox,'width:100%;height:'+box_height+'px;position:relative;top:0;left:0;background:rgba(0,0,0,1)');
	
	//创建视频播放背景
	var v_bg=create('div',box,'background:#000;');

	//创建视频
	var video=create('video',v_bg,'width:100%;height:100%;');
	$(video).attr('playsinline',true);//ios禁止默认全屏
	$(video).attr('webkit-playsinline',true);//ios禁止默认全屏
	$(video).attr('x5-playsinline',true);//安卓禁止默认全屏
	$(video).attr('x-webkit-airplay','allow');//
	$(video).attr('controls',false);//禁止默认工具
	
	$(video).attr('preload','none');
	//$(video).attr('x5-video-player-type','h5');//h5新个性
	
	if(param.poster) $(video).attr('poster',param.poster);
	
	//播放遮罩
	var v_pre=create('div',box,'position:absolute;width:100%;top:0px;left:0px;bottom:0px;');
	var v_style=create('style',v_pre);
	v_style.type = "text/css";
	
	var str='@-webkit-keyframes loader-02 {0% {-webkit-transform: rotate(0deg);transform: rotate(0deg);}100% {-webkit-transform: rotate(360deg);transform: rotate(360deg);}}@keyframes loader-02{0% {-webkit-transform: rotate(0deg);transform: rotate(0deg);}100% {-webkit-transform: rotate(360deg);transform: rotate(360deg);}}';
	
	try{
	　　v_style.appendChild(document.createTextNode(str));
	}catch(ex){
	　　v_style.styleSheet.cssText =str;//针对IE
	}
	var s='position:absolute;width:100%;top:0px;left:0px;bottom:0px;color:#fff;';
	
	//正在播放
	var v_pre_playing=create('div',v_pre,s);
	v_pre_playing.onclick=function(){
		if($(v_header).css('display')=='block')
		{
			$(v_header).hide();
			$(f).hide();
		}
		else
		{
			$(v_header).show();
			$(f).show();
			video.time=0;
		}
	}
	
	//载入
	var v_pre_load=create('div',v_pre,s+'display:none;z-index:1;background:rgba(0,0,0,0.4);');
	var a=create('div',v_pre_load,flex_col);
	create('div',a,flex_son);
	create('div',a,'margin:0 auto;width: 1em;height: 1em;color: inherit;vertical-align: middle;pointer-events: none;border: .2em solid transparent;border-left-color: currentcolor;border-right-color: currentcolor;border-radius: 50%;-webkit-animation: 1s loader-02 linear infinite;animation: 1s loader-02 linear infinite;');
	create('div',a,flex_son);
	
	//播放按钮
	var v_pre_play=create('div',v_pre,s+'z-index:1;background:rgba(0,0,0,0.4);');
	var a=create('div',v_pre_play,flex_col);
	create('div',a,flex_son);
	var v_pre_play_btn=create('div',a,'width:2em;height:2em;font-size:1.5em;margin: 0 auto;position: relative;border:5px solid #fff;background: rgba(0,0,0,0.8);border-radius: 50%;');
	create('div',v_pre_play_btn,'width: 0;height: 0;border-width:0.6em 0 0.6em 1em;border-style: solid;border-color: transparent transparent transparent #fff;position: absolute;top:0.4em;left:0.65em;border-radius:0.2em;');
	create('div',a,flex_son);
	//开始播放
	v_pre_play_btn.onclick=function(){
		video.play();
	}
	
	//头部
	var v_header=create('div',box,'background:rgba(0,0,0,0.5);position:absolute;top:0px;left:0px;width:100%;display:block;z-index:1;');
	var v_header_box=create('div',v_header,'font-size:1em;display: -webkit-box;display: -webkit-flex;display: flex;');
	var v_header_back=create('div',v_header_box,'position:relative;width:2.4em;height:2.2em;margin-left:8px;display:none;');
	create('div',v_header_back,'position:absolute;content:" ";display:block;border: solid #fff;border-width: 0 1.5px 1.5px 0;-webkit-transform: rotate(135deg);font-size:1em;width:0.8em;height:0.8em;left:0.8em;top:0.8em;');
	
	v_header_back.onclick=function(){
		if($(f_screen).css('display')=='none')
		{
			checkScreen('exitscreen');
		}
		else
		{
			_this.call({eventType:'close'});
		}
	}
	if(param.back) $(v_header_back).show();
	
	//标题
	if(param.title)
	{
		var v_header_title=create('div',v_header_box,'text-align:center;line-height:1em;padding:0.6em 0;color:#fff;font-size:1em;');
		v_header_title.innerHTML=param.title;
	}		
	
	create('div',v_header_box,flex_son);
	
	//工具
	var v_header_tool=create('div',v_header_box,'position:relative;width:2.4em;height:0.4em;display: -webkit-box;display: -webkit-flex;display: flex;padding:0.8em 0;');
	create('div',v_header_tool,'-webkit-box-flex: 1;-webkit-flex: 1;flex:1;font-size:0.8em;');
	create('div',v_header_tool,'width:0.3em;height:0.3em;border-radius: 50%;background: #FFF;margin:0.05em 0.1em;');
	create('div',v_header_tool,'width:0.45em;height:0.45em;border-radius: 50%;background: #FFF;margin:0 0.1em;');
	create('div',v_header_tool,'width:0.3em;height:0.3em;border-radius: 50%;background: #FFF;margin:0.05em 0.1em;');
	create('div',v_header_tool,'-webkit-box-flex: 1;-webkit-flex: 1;flex:1;');
	
	//底部
	var f=create('div',box,'background:rgba(0,0,0,0.5);position:absolute;bottom:0px;left:0px;width:100%;display:block;z-index:1;');
	var f_box=create('div',f,'padding:0.2em 0.9em;overflow:hidden;display: -webkit-box;display: -webkit-flex;display: flex;');
	
	//播放按钮
	var f_play=create('div',f_box,'position:relative;width:1.8em;height:2em;');
	create('div',f_play,'content:"";width:0;height:0;border-width:0.55em 0 0.55em 0.9em;border-style:solid;border-color:transparent transparent transparent #fff;position:absolute;top:0.5em;left:0.5em;border-radius:1px;');
	//开始播放
	f_play.onclick=function(){
		video.play();
	}
	
	//暂停按钮
	var f_pause=create('div',f_box,'position:relative;width:1.8em;height:2em;display:none;');
	create('div',f_pause,'position:absolute;content:"";width:0.25em;height:1em;background:#fff;border-radius:0.05em;top:0.5em;left:0.5em;');
	create('div',f_pause,'position:absolute;content:"";width:0.25em;height:1em;background:#fff;border-radius:0.05em;top:0.5em;right:0.5em;');
	//暂停播放
	f_pause.onclick=function(){
		video.pause();
	}
	
	//播放时间
	var f_currenttime=create('div',f_box,'color:#FFF;1em;height:1em;font-size:0.8em;margin:0.55em 0.5em;');
	f_currenttime.innerHTML='0.00';
	//设置播放时间
	f_currenttime.set=function(){
		$(this).html(formatTime(video.currentTime || 0));
	}
	
	//进度条
	var f_pr=create('div',f_box,'height:1em;position:relative;margin:0.5em 0;-webkit-box-flex: 1;-webkit-flex: 1;flex:1;');
	
	var x_point=0;
	//开始
	f_pr.ontouchstart=function(ev){
		ev.preventDefault();
		f_pr.move=true;
		x_point=ev.targetTouches[0].clientX;
	}
	//移动
	f_pr.ontouchmove=function(ev){
		var x_dis=ev.targetTouches[0].clientX-x_point;
		var w=$(f_pr_line_play).width()+x_dis;
		$(f_pr_line_play).width(w);
		x_point=ev.targetTouches[0].clientX;
	}
	
	f_pr.ontouchend=function(ev){
		ev.returnValue = true;
		f_pr.move=false;
		//设置播放位置
		video.setCurrenttime();
	}
	
	//总长度
	var f_pr_all=create('div',f_pr,'height:0.2em;background:rgba(255,255,255,0.2);top:0.4em;position:absolute;width:100%;border-radius:0.2em;');
	
	//缓冲
	var f_pr_buffered=create('div',f_pr,'height:0.2em;background:rgba(255,255,255,0.3);top:0.4em;position:absolute;width:0;border-radius:0.2em;');
	
	//播放进度
	var f_pr_line=create('div',f_pr,'top:0.23em;position:absolute;width:100%;display: -webkit-box;display: -webkit-flex;display: flex;');
	
	var f_pr_line_play=create('div',f_pr_line,'height:0.2em;background:rgba(255,255,255,0.8);margin-top:0.15em;width:0;border-radius:0.2em;');
	
	//移动位置
	f_pr_line_play.setWidth=function(){
		//当移动播放位置时禁止显示当前播放位置
		if(f_pr.move) return;
		
		var w=video.currentTime/video.duration*$(f_pr_all).width() || 0;
		$(this).width(w);
		f_currenttime.set();
		
		if($(v_header).css('display')=='block')
		{
			video.time++;
			if(video.time>20)
			{
				$(v_header).hide();
				$(f).hide();
			}
		}
	}
	
	var f_pr_line_boll=create('div',f_pr_line,'width:0.5em;height:0.5em;background:rgba(255,255,255,0.8);margin-top:0em;border-radius:50%;');
	create('div',f_pr_line,'-webkit-box-flex: 1;-webkit-flex: 1;flex:1;');
	
	//总时间
	var f_duration=create('div',f_box,'color:#FFF;1em;height:1em;font-size:0.8em;margin:0.55em 0.5em;');
	f_duration.innerHTML='0.00';
	//设置时间长度
	f_duration.set=function(){
		$(this).html(formatTime(video.duration || 0));
	}
	
	//倍速
	var f_rate=create('div',f_box,'color:#FFF;1em;height:1em;font-size:0.8em;margin:0.55em 0.5em;');
	f_rate.innerHTML='倍速';
	f_rate.onclick=function(){
		//倍速调整
		//载入
		var rate=create('div',box,s+'height:100%;background:rgba(0,0,0,0.2);z-index:10;');
		var l=create('div',rate,'width:70%;height:100%;float:left;');
		l.onclick=function(){$(rate).remove();}
		var a=create('div',rate,'width:30%;height:100%;float:right;background:rgba(0,0,0,0.9);');
		var ab=create('div',a,flex_col);
		var a1=create('div',ab,'text-align:center;color:#FFF;font-size:1em;padding:1em 0;');
		a1.innerHTML='1X';
		var a2=create('div',ab,flex_son);
		var a21=create('div',a2,'width:3px;height:90%;background:rgba(255,255,255,0.2);margin:0 auto;position:relative;');
		var a211=create('div',a21,'width:3px;height:0%;background:rgba(255,255,255,1);position:absolute;bottom:0;');
		
		var mh=$(a21).height();
		var y=0;
		//开始
		a2.ontouchstart=function(ev){
			ev.preventDefault();
			y=ev.targetTouches[0].clientY;
		}
		//移动
		a2.ontouchmove=function(ev){
			var y_dis=ev.targetTouches[0].clientY-y;
			console.log('y_dis='+y_dis);
			var h=$(a211).height()-y_dis;
			h=Math.min(mh,h);
			if(h<0.1*mh) h=0.1*mh;
			$(a211).height(h);
			var v=h/mh*3;
			$(a1).html(v.toFixed(1)+'X');
			video.playbackRate=v;
			y=ev.targetTouches[0].clientY;
		}
		a2.ontouchend=function(ev){
			ev.returnValue = true;
		}
		$(a211).height(video.playbackRate/3*mh);
	}
	
	var f_screen=create('div',f_box,'font-size:0.9em;width:1.2em;height:1.2em;margin:0.6em 0.2em 0 0.6em;position:relative;');
	create('div',f_screen,'position:absolute;border: solid #FFF;border-width: 1.5px 0 0 1.5px;width:0.4em;height:0.4em;left:0;top:0;border-radius:0.2em 0 0 0;');
	create('div',f_screen,'position:absolute;border: solid #FFF;border-width: 1.5px 1.5px 0 0;width:0.4em;height:0.4em;right:0;top:0;border-radius:0 0.2em 0 0;');
	create('div',f_screen,'position:absolute;border: solid #FFF;border-width:0 1.5px 1.5px 0 ;width:0.4em;height:0.4em;right:0;bottom:0;border-radius:0 0 0.2em 0;');
	create('div',f_screen,'position:absolute;border: solid #FFF;border-width:0 0 1.5px 1.5px;width:0.4em;height:0.4em;left:0;bottom:0;border-radius:0 0 0 0.2em;');
	
	f_screen.onclick=function(){
		//安卓手机监控是否横屏
		checkScreen('fullscreen');
	}
	
	var f_s_quit=create('div',f_box,'font-size:0.9em;width:1.2em;height:1.2em;margin:0.6em 0.2em 0 0.6em;position:relative;display:none;');
	create('div',f_s_quit,'position:absolute;border: solid #FFF;border-width: 1.5px 0 0 1.5px;width:0.4em;height:0.4em;right:0;bottom:0;border-radius:0.2em 0 0 0;');
	create('div',f_s_quit,'position:absolute;border: solid #FFF;border-width: 1.5px 1.5px 0 0;width:0.4em;height:0.4em;left:0;bottom:0;border-radius:0 0.2em 0 0;');
	create('div',f_s_quit,'position:absolute;border: solid #FFF;border-width:0 1.5px 1.5px 0 ;width:0.4em;height:0.4em;left:0;top:0;border-radius:0 0 0.2em 0;');
	create('div',f_s_quit,'position:absolute;border: solid #FFF;border-width:0 0 1.5px 1.5px;width:0.4em;height:0.4em;right:0;top:0;border-radius:0 0 0 0.2em;');
	f_s_quit.onclick=function(){
		//安卓手机监控是否横屏
		checkScreen('exitscreen');
	}
	
	//设置时间
	video.setCurrenttime=function(){
		var width=$(f_pr_line_play).width();
		var duration=video.duration;
		var currentTime=width/$(f_pr_all).width()*duration || 0;
		video.currentTime=currentTime;
	}
	
	var msg='';
	/*
	//当发生中止事件时运行脚本
	video.onabort=function(){
		alert('onabort');
	}
	*/
	
	/*
	//当媒介能够无需因缓冲而停止即可播放至结尾时运行脚本
	video.oncanplaythrough=function(){
		alert('oncanplaythrough');
	}
	*/
	/*
	//当媒介长度改变时运行脚本
	video.ondurationchange=function(){
		alert('ondurationchange');
	}
	*/
	
	//当媒介资源元素突然为空时（网络错误、加载错误等）运行脚本
	video.onemptied=function(){
		error_num++;
		console.log('onemptied');
		msg='资源不存在';
	}
	
	//当媒介已抵达结尾时运行脚本
	video.onended=function(){
		if(param.playtype=='loop')
		{
			_this.call({eventType:'next',type:'loop'});
		}
		else if(param.playtype=='oneloop')
		{
			video.setCurrenttime(0);
			video.play();
		}
		else
		{
			_this.call({eventType:'end'});
		}
	}
	
	//当在元素加载期间发生错误时运行脚本
	video.onerror=function(ret){
		error_num++;
		console.log('onerror'+error_num+msg);
		if(error_num>4)
		{
			if(!msg) msg='未知错误';
			api.alert({msg:msg+JSON.stringify(ret)});
		}
		else
		{
			setTimeout(function(){
				video.play();
			},500)			
		}
	}
	
	
	//当加载媒介数据时运行脚本
	video.onloadeddata=function(){
		console.log('onloadeddata');
	}
	
	
	//当媒介元素的持续时间以及其他媒介数据已加载时运行脚本
	video.onloadedmetadata=function(){
		console.log('onloadedmetadata');
	}
	
	//当浏览器开始加载媒介数据时运行脚本
	video.onloadstart=function(){
		console.log('onloadstart');
	}
	
	//当媒介数据暂停时运行脚本
	video.onpause=function(){
		$(f_pause).hide();
		$(f_play).show();
		$(v_pre_play).show();
		$(v_header).show();
		$(f).show();
		video.time=0;
		_this.call({eventType:'pause'});
	}
	
	//当媒介数据将要开始播放时运行脚本
	video.onplay=function(){
		error_num=0;
		$(f_pause).show();
		$(f_play).hide();
		$(v_pre_play).hide();
		$(v_pre_load).show();
		video.time=0;
		_this.call({eventType:'play'});
	}
	
	//当媒介数据已开始播放时运行脚本
	video.onplaying=function(){
		f_duration.set();
		$(v_pre_load).hide();
		_this.call({eventType:'onplaying',duration:video.duration});
	}
	
	/*
	//当浏览器正在取媒介数据时运行脚本
	video.onprogress=function(ret){
		api.toast({msg:'onprogress'+JSON.stringify(ret)});
	}
	*/
	/*
	//当媒介数据的播放速率改变时运行脚本
	video.onratechange=function(ret){
		api.toast({msg:'onratechange'+JSON.stringify(ret)});
	}
	*/
	/*
	//当就绪状态（ready-state）改变时运行脚本
	video.onreadystatechange=function(ret){
		api.toast({msg:ret});
	}
	*/
	/*
	//当媒介元素的定位属性 [1] 不再为真且定位已结束时运行脚本
	video.onseeked=function(ret){
		api.toast({msg:'onseeked'+JSON.stringify(ret)});
	}
	*/
	/*
	//当媒介元素的定位属性为真且定位已开始时运行脚本
	video.onseeking=function(ret){
		api.toast({msg:'onseeking'+JSON.stringify(ret)});
	}
	*/
	/*
	//当取回媒介数据过程中（延迟）存在错误时运行脚本
	video.onstalled=function(ret){
		api.toast({msg:'onstalled'+JSON.stringify(ret)});
	}
	*/
	/*
	//当浏览器已在取媒介数据但在取回整个媒介文件之前停止时运行脚本
	video.onsuspend=function(ret){
		api.toast({msg:'onsuspend'+JSON.stringify(ret)});
	}
	*/
	
	//当媒介改变其播放位置时运行脚本
	video.ontimeupdate=function(ret){
		f_pr_line_play.setWidth();
	}
	
	/*
	//当媒介改变音量亦或当音量被设置为静音时运行脚本
	this.video.onvolumechange=function(ret){
		api.toast({msg:'onvolumechange'+JSON.stringify(ret)});
	}
	*/
	/*
	//当媒介已停止播放但打算继续播放时运行脚本
	this.video.onwaiting=function(ret){
		api.toast({msg:'onwaiting'+JSON.stringify(ret)});
	}
	$('#'+id).append(this.video);
	*/
				
	
	//回调
	this.call=function(ret){
		func && func(ret);
	}
	
	//创建元素
	function create(name,par,style){
		var div=document.createElement(name);
		$(par).append(div);
		if(style) $(div).attr('style',style);
		return div;
	}
	//格式化时间
	function formatTime(t){
		var str='';
		var m=Math.round(t / 60);
		if(m)
		{
			if(m>60)
			{
				var h=Math.round(m / 60);
				if(h<10) h='0'+h;
				str+=h+':';
				var m=Math.round(m % 60);
			}
			if(m<10) m='0'+m;
			str+=m+':';
		}
		else
		{
			str+='00:';
		}
		
		var s=Math.round(t % 60);
		if(s<10) s='0'+s;
		str+=s;
		return str;
	}
	
	
	//检测屏幕状态
	function checkScreen(type,loop){
		if(type=='fullscreen')
		{
			//横屏
			if(!loop) api.setScreenOrientation({orientation: 'landscape_left'});
			if($(f_screen).css('display')=='none') return;
		}
		else
		{
			//竖屏
			if(!loop) api.setScreenOrientation({orientation: 'portrait_up'});
			if($(f_s_quit).css('display')=='none') return;
		}
		resize();
		setTimeout(function(){
			checkScreen(type,true);
		},100)
	}
	
	//重置播放窗口尺寸
	function resize(){
		//竖屏
		if(api.winWidth> api.winHeight)
		{
			if($(f_s_quit).css('display')=='none')
			{
				//禁止屏幕休眠
				api.setKeepScreenOn({keepOn: true});
				//屏幕全屏
				api.setFullScreen({fullScreen: true,animation:'slide'});
				api.setFrameAttr({
					name: api.frameName,
					rect:{h:W_width,y:0}
				});
				$(box).css('z-index',99999);
				$(box).css('position','fixed');
				$(box).height(api.winHeight);
				$(f_screen).hide();
				$(f_s_quit).show();
				$(v_header_back).show();
			}
		}
		//横屏
		else
		{
			if($(f_screen).css('display')=='none')
			{
				//关闭禁止屏幕休眠
				api.setKeepScreenOn({keepOn: false});
				//退出全屏
				api.setFullScreen({fullScreen: false,animation:'slide'});
				api.setFrameAttr({
					name: api.frameName,
					rect:{h:F_height,y:F_top}
				});
				
				$(box).css('position','relative');
				$(box).css('z-index',1);
				$(box).height(box_height);
				$(f_screen).show();
				$(f_s_quit).hide();
				if(!param.back) $(v_header_back).hide();
				setTimeout(function(){
					$(document).scrollTop($(box).offset().top);
				},100)
			}
		}
	}
	
	var _this=this;
	video.src=param.url;
	if(param.isplay)
	{
		video.play();
		if(param.currentTime)
		{
			var currentTime=param.currentTime;
			setTimeout(function(){
				video.setCurrenttime(currentTime);
			},1000)
		}
	}
}