/*
	会员登陆
*/
Plug.member={
	inc:'member',
	module:'member',
	url:'https://i.xuezizhai.com/index.php?s=40',
	func:'',
	mid:0,
	/*
	请求服务器获取数据
	para 请求参数
	func 回调函数
	*/
	getmData:function(para,func,data){
		url=this.url;
		//登陆来源
		para.from_type=App.config.fromtype || '';
		getmData(para,function(ret,err){
			func && func(ret,err);
		},data,url)
	},
	/**检测真是登陆
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	trueLogin:function(func){
		var self=this;
		this.isLogin(function(ret){
			if(ret.status)
			{
				//同步服务器登陆信息
				self.update(function(ret){
					if(ret.status)
					{
						func && func(ret);
					}
					else
					{
						//设备自动登陆
						self.device.login(function(ret){
							func && func(ret);
						})
					}
				})
			}
			else
			{
				func && func(ret);
			}
		})
	},
	/**更新登陆信息
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	update:function(func){
		var self=this;
		var item={cm:'getinfo'};
		Plug.member.getmData(item,function(ret){
			if(ret.status==3)
			{
				self.set(ret.data);
				func && func({status:true,data:ret.data});
			}
			else
			{
				func && func({status:false});
			}
		})
	},
	/**检测会员是否登陆
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	isLogin:function(func){
		var self=this;
		//异步返回结果：
		api.getPrefs({
			key: 'member'
		}, function(ret, err)
		{
			if(ret.value)
			{
				var retback={};
				try{
					var item=$api.strToJson(ret.value);
					if(typeof(item)=='object')
					{
						self.mid=item.mid;
						retback={status:true,data:item};
					}
					else
					{
						self.mid=0;
						retback={status:false,data:'未登录'};
					}
				}
				catch(err)
				{
					self.mid=0;
					retback={status:false,data:'未登录'};
			　　}
				func && func(retback);
			}
			else
			{
				self.mid=0;
				func && func({status:false,data:'未登录'});
			}
		});
	},
	/**打开登陆界面
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	login:function(func,logintype,jump){
		this.quit();
		var self=this;
		var deal=function(){
			var pageParam={};
			if(logintype) pageParam.logintype=logintype;
			if(jump) pageParam.jump=jump;
			var item={name:self.inc+'/login',pageParam:pageParam};
			item.func=func;
			item.animation={type:'movein',subType:'from_bottom',duration:300};
			App.Frame.open(item);
		}
		switch(logintype)
		{
			case 'qq':
				this.qq.check(function(ret){
					if(ret.status)
					{
						self.qq.open(function(ret){
							if(ret.status)
							{
								func && func({eventType:'success',data:ret.data});
							}
							else
							{
								api.toast({msg:ret.data});
								func && func({eventType:'close',data:ret.data});
							}
						});
					}
					else
					{
						deal();
					}
				})
			break;
			case 'weixin':
				this.weixin.check(function(ret){
					if(ret.status)
					{
						self.weixin.open(function(ret){
							if(ret.status)
							{
								func && func({eventType:'success',data:ret.data});
							}
							else
							{
								api.toast({msg:ret.data});
								func && func({eventType:'close',data:ret.data});
							}
						});
					}
					else
					{
						deal();
					}
				})
			break;
			default:
				deal();
			break;
		}
	},
	/**设置年级
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	cl1:function(func){
		this.func=func;
		var name=this.module+'/levelsel';
		var pageParam={};
		var item={name:name,pageParam:pageParam};
		item.func=func;
		item.bgColor='rgba(0 , 0, 0,0.7)';
		App.Frame.open(item);
	},
	/**设置学校
	 *  
	 * @access    public
	 * @param     function  func 回调函数
	 * @return    string
	 */
	school:function(func){
		this.func=func;
		var para={winName:api.winName,frameName:api.frameName,func:'Plug.member.back'};
		var item={name:this.inc+'/school',para:para};
		App.Win.open(item);
	},
	/**回调函数
	 *  
	 * @access    public
	 * @param     object  ret 回调参数
	 * @return    string
	 */
	back:function(ret){
		this.func && this.func(ret);
		this.func='';
	},
	/**会员管理
	 *  
	 * @access    public
	 * @param     object  ret 回调参数
	 * @return    string
	 */
	index:function(){
		App.Win.open({name:this.inc+'/index'});
	},
	//缓存会员信息
	set:function(data,func){
		data.cachetime = Date.parse(new Date());
		var str=JSON.stringify(data);
		api.setPrefs({
			key: 'member',
			value: str
		});
		
		var mid=data.aid;
		this.mid=mid;
		
		this.device.bind(data,function(){
			func && func();
		})
	},
	/**退出登录
	 *  
	 * @access    public
	 * @param     object  ret 回调参数
	 * @return    string
	 */
	quit:function(func){//退出登陆
		api.removePrefs({key: 'member'});
		this.mid=0;
		var item={cm:'quit'};
		this.getmData(item,function(ret){
			func && func(ret);
		});
	},
	//登陆成功d处理
	success:function(data,func){
		//保存会员信息
		this.set(data,function(){
			//检测用户是否绑定手机号码
			Plug.open('mobile',function(){
				Plug.mobile.check(function(ret){
					if(ret.status)
					{
						data=ret.data;
					}
					//极光推送 绑定推送账号
					Plug.open('ajpush',function(){
						Plug.ajpush.bind(function(){
							func && func({status:true,data:data});
						});
					})	
				});
			})
		});
	},
	//设备
	device:{
		key:'member_device',
		//绑定设备
		bind:function(user,func){
			var self=this;
			var data={};
			data.deviceid=api.deviceId;
			data.action=1;
			var para={view:'device',cm:'bind'};
			Plug.member.getmData(para,function(ret){
				if(ret.status==3)
				{
					var item=ret.data;
					Plug.open('cache',function(){
						Plug.cache.set(self.key,item,function(){
							func && func();
						});
					})
				}
				else
				{
					func && func();
				}
			},data);
		},
		//设备登陆
		login:function(func){
			var self=this;
			var data={};
			data.deviceid=api.deviceId;
			data.action=1;
			var para={view:'device',cm:'login'};
			Plug.member.getmData(para,function(ret){
				if(ret.status==3)
				{
					Plug.member.set(ret.data);
					func && func({status:true,data:ret.data});
				}
				else
				{
					func && func({status:false});
				}
			},data);
		},
		vipLogin:function(func){
			var self=this;
			Plug.open('cache',function(){
				Plug.cache.get(self.key,function(ret){
					if(ret.status && ret.data.vipmid)
					{
						var data=ret.data;
						var param={view:'device',cm:'vipcheck'};
						Plug.member.getmData(param,function(ret){
							//VIP会员
							if(ret.status==3)
							{
								var pageParam={};
								pageParam.data=ret.data;
								var item={name:'member/device_vip',pageParam:pageParam};
								item.bgColor='rgba(0 ,0, 0,0.1)';
								item.func=func;
								item.animation={type:'movein',subType:'from_bottom',duration:300};
								App.Frame.open(item);
							}
							//vip已过期或不存在
							else if(ret.status==2)
							{
								var item=ret.data;
								Plug.open('cache',function(){
									Plug.cache.set(self.key,item,function(){
										func && func();
									});
								})
							}
							else
							{
								func && func();
								//其他错误
								//api.toast({msg:ret.data});
							}
						},data);
					}
					else
					{
						func && func({status:false});
					}
				});
			})
		}
	},
	//微信登陆
	weixin:{
		check:function(func){
			var wx = api.require('wx');
			//未安装微信登陆插件
			if(wx==undefined)
			{
				func && func({status:false});
				return;
			}
			wx.isInstalled(function(ret, err) {
				if (ret.installed)
				{
					func && func({status:true});
				}
				else
				{
					func && func({status:false});
				}
			});
		},
		//登录授权（用于实现第三方登录）
		open:function(func){
			var self=this;
			var para={login:App.config.login_weixin,cm:'getappid'};
			Plug.member.getData(para,function(ret){
				if(ret.status==3)
				{
					var wx = api.require('wx');
					wx.auth({
						apiKey:ret.data
					}, function(ret, err)
					{
						if (ret.status)
						{
							self.login(ret.code,func);
						}
						else
						{
							switch(err.code)
							{
								case 1:
									func && func({status:false,data:'取消登录'});
								break;
								case 2:
									func && func({status:false,data:'拒绝授权'});
								break;
								case 3:
									func && func({status:false,data:'未安装微信客户端'});
								break;
								default:
									func && func({status:false,data:'请重新登陆'});
								break;
							}
							Log.system('微信登陆失败,'+JSON.stringify(err),1);
						}
					});
				}
				else
				{
					func && func({status:false,data:'请使用其他登陆方式'});
					Log.system('微信登陆获取配置，'+ret.data,1);
				}
			})
		},
		login:function(code,func){
			var para={login:App.config.login_weixin,cm:'login'};
			var data={code:code};
			Plug.member.getData(para,function(ret){
				if(ret.status==3)
				{
					Plug.member.success(ret.data,func);
				}
				else
				{
					func && func({status:false,data:'登陆失败'});
					Log.system('微信登陆失败，'+ret.data,1);
				}
			},data)
		}
	},
	//QQ登陆
	qq:{
		check:function(func){
			var qq = api.require('QQPlus');
			//未安装QQ登陆插件
			if(qq==undefined)
			{
				func && func({status:false});
				return;
			}
			qq.installed(function(ret, err){
				if (ret.status)//已安装
				{
					func && func({status:true,qq:qq});
				}
				else//未安装
				{
					func && func({status:false});
				}
			});
		},
		//打开QQ
		open:function(func){
			var self=this;
			var qq = api.require('QQPlus');
			qq.login(function(ret, err){
				if(ret.status)
				{
					self.login(ret,func);
				}
				else
				{
					Log.system('QQ登陆 调启QQ失败，'+err.msg,1);
					func && func({status:false,data:err.msg});
				}
			});
		},
		//登陆
		login:function(item,func){
			var self=this;
			LoadMsg.show({title:'努力加载中...',time:5000},function(){
				func && func({status:false,data:'登陆超时'});
				func='';
			});
			var data={openid:item.openId,access_token:item.accessToken};

			var para={login:App.config.login_qq,cm:'login'};
			Plug.member.getData(para,function(ret){
				LoadMsg.close();//关闭提示
				if(ret.status==3)//登陆成功
				{
					Plug.member.success(ret.data,func);
				}
				else if(ret.status==2)//帐号未注册
				{
					self.getUserInfo(item.openId,func);
				}
				else if(ret.status==4)//帐号已删除
				{
					self.getUserInfo(item,func);
				}
				else
				{
					//获取失败
					api.confirm({
						title: '提示',
						msg: '登陆失败，重新登陆',
						buttons: ['确定', '取消']
					}, function(ret, err)
					{
						if(ret.buttonIndex==1)
						{
							self.open(func);
						}
						else
						{
							func && func({status:false,data:'取消登录'});
						}
					});
				}
			},data);
		},
		//获取用户信息
		getUserInfo:function(openid,func){
			var self=this;
			var qq = api.require('QQPlus');
			qq.getUserInfo(function(ret, err)
			{
				if (ret.status)
				{
					ret.info.openid=openid;
					self.register(ret.info,func);
				}
				else
				{
					func && func({status:false,data:err.msg});
					Log.system('QQ登陆 获取信息失败'+err.msg,1);
				}
			});
		},
		//注册
		register:function(data,func){
			data.deviceid=api.deviceId;
			var para={cm:'qqregister'};
			Plug.member.getData(para,function(ret){
				if(ret.status==3)//注册成功
				{
					D.success(ret.data,func);
				}
				else if(ret.status==2)//帐号未注册
				{
					api.alert({msg:ret.data});
				}
				else
				{
					Log.system('QQ登陆 注册失败'+ret.data,1);
					func && func({status:false,data:'登陆失败'});
				}
			},data);
		}
	},
	//我的书本
	mybook:{
		click:function(item){
			Plug.member.isLogin(function(ret){
				if(ret.status)
				{
					var cl1=item.cl1;
					var cl2=item.cl2;
					var cl3=item.cl3;
					if(!cl3 || !cl2 || !cl3) return;
					var param={module:'mybook',view:'stow',cm:'click',cl1:cl1,cl2:cl2,cl3:cl3};
					Plug.member.getmData(param,function(ret){
						
					})
				}
			})
		}
	}
}