/*
	支付
*/
Plug.pay={
	func:'',
	item:{},
	name:'pay/pay',
	//选择付款方式包含金币
	type:function(data,func){
		if(api.systemType=='ios')
		{
			//虚拟产品
			if(data.fictitious)
			{
				this.iap.init(data,func);
				return;
			}
		}
		
		//打开支付方式选择
		var item={};
		item.name=this.name+'_type';
		item.pageParam={};
		item.pageParam.data=data;
		item.func=func;
		item.animation={type:'movein',subType:'from_bottom',duration:300};
		App.Frame.open(item);
	},
	//获取支付方式
	gettype:function(func,data){
		if(typeof(data)!='object') data={};
		var self=this;
		var item={module:'pay',view:'paytype',cm:'getlists'};
		//苹果内购	
		if(api.systemType=='ios')
		{
			item.device='app';
			//虚拟产品
			if(data.fictitious)
			{
				func && func({status:3,data:[]});
				return;
			}
			else
			{
				item.systemtype='ios';
			}
			if(App.config.channel)
			{
				var channel=App.config.channel;
				item.channel=channel;
			}
		}
		else
		{
			item.device='mobile';
		}
		Plug.member.getmData(item,function(ret){
			func && func(ret);
		})
	},
	//开始支付
	start:function(param,func){
		this.item=param;
		var view=param.view;
		this[view](param,func);
	},
	//苹果内购
	iap:{
		countKey:'plug_pay_iap_count',
		init:function(data,func){
			var self=this;
			var item={module:'pay',view:'iap',cm:'getitem'};
			item.aid=data.aid;
			item.paytype=6;
			Plug.member.getmData(item,function(ret,err){
				if(ret.status==3)
				{
					self.open(ret.data,func);
				}
				//
				else if(ret.status==4)
				{
					api.confirm({
						title: '提示',
						msg: ret.data,
						buttons: ['重试', '取消']
					}, function(ret, err){
						if(ret.buttonIndex==1)
						{
							self.init(data,func);
						}
					});
				}
				else
				{
					api.alert({msg:ret.data});
				}
			})
		},
		open:function(item,func){
			var self=this;
			var iap = api.require('iap');
			api.showProgress({
				title: '加载中...',
				text: '请稍等...',
				modal: false
			});
			
			iap.purchase({
				productId: item.product,
				applicationUsername:item.aid
			}, function(ret, err){
				if (ret)
				{
					if(ret.state==1)
					{
						api.hideProgress();
						self.save(item.aid,ret,func);
					}
					else if(ret.state==2)
					{
						api.hideProgress();
						self.copen(item,func);
					}
					else if(ret.state==3)
					{
						api.hideProgress();
						func && func({status:1,data:'恢复购买'});
					}
					else if(ret.state==4)
					{
						api.hideProgress();
						func && func({status:1,data:'交易等待被确认'});
					}
				}
				else
				{
					api.hideProgress();
					//其它错误，如参数错误、如当前用户不能使用应用内购买等
					func && func({status:1,data:err.msg});
				}
			});
		},
		//支付失败开启验证页面
		copen:function(item,func){
			if(!App.config.iospay)
			{
				func && func({status:1,data:'取消或交易失败'});
				return;
			}
			var self=this;
			Plug.open('cache',function(){
				Plug.cache.get(self.countKey,function(ret){
					var num=parseInt(ret.status ? ret.data : 1);
					if(num>=parseInt(App.config.iospay))
					{
						var param={name:'pay/pay_iap'};
						param.bgColor='rgba(0 , 0, 0,0.5)';
						param.pageParam={};
						param.pageParam.data=item;
						param.func=func;
						param.animation={type:'movein',subType:'from_bottom',duration:300};
						App.Frame.open(param);
						num=1;
					}
					else
					{
						num++;
						func && func({status:1,data:'取消或交易失败'});
					}
					Plug.cache.set(self.countKey,num);
				})
			})
		},
		save:function(aid,post,func){
			var self=this;
			var item={module:'pay',view:'iap',cm:'save',aid:aid};
			Plug.member.getmData(item,function(ret){
				if(ret.status==3)
				{
					self.check(aid,func);
				}
				else if(ret.status==4)
				{
					api.confirm({
						title: '提示',
						msg: '遇到的小错误',
						buttons: ['重试', '取消']
					}, function(ret, err){
						if(ret.buttonIndex==1)
						{
							self.save(aid,post,func);
						}
					});
				}
				else
				{
					func && func({status:1,data:'未知错误'});
				}
			},post)
		},
		//验证凭证
		check:function(aid,func){
			var self=this;
			var item={module:'pay',view:'iap',cm:'check',aid:aid};
			Plug.member.getmData(item,function(ret){
				if(ret.status==4)
				{
					api.confirm({
						title: '提示',
						msg: '验证失败，请点击重试',
						buttons: ['重试', '取消']
					}, function(ret, err){
						if(ret.buttonIndex==1)
						{
							self.check(aid,func);
						}
					});
					return;
				}
				func && func(ret);
				if(ret.status==3)
				{
					self.finish(ret.data);
				}
			})
		},
		//监听
		listener:function(){
			var self=this;
			var iap = api.require('iap');
			iap.setTransactionListener({autoFinishTransaction:false},function(ret, err) {
				if (ret)
				{
					if(ret.state==1)
					{
						var aid=ret.applicationUsername;
						var transactionId=ret.transactionId;
						//保存支付凭证
						var item={module:'pay',view:'iap',cm:'save',aid:aid};
						Plug.member.getmData(item,function(ret){
							if(ret.status==3)
							{
								setTimeout(function(){
									//检测支付记录
									var item={module:'pay',view:'pay',cm:'check',aid:aid};
									Plug.member.getmData(item,function(ret){
										if(ret.status==3)
										{
											//更新会员信息
											Plug.open('member',function(){
												Plug.member.update();
											})
											self.finish({transactionId:transactionId});
										}
									})
								},30000)
							}
						},ret)
					}
				}
			});
		},
		//完成交易
		finish:function(item){
			var iap = api.require('iap');
			iap.finishTransaction({transactionId:item.transactionId});
		}
	},
	//微信支付
	weixin:function(param,func){
		var item={name:'pay/pay_weixin',pageParam:{data:param}};
		item.func=function(ret){
			if(ret.eventType=='success')
			{
				var re={status:3,data:ret.data};
			}
			else
			{
				var re={status:1,data:'未支付'};
			}
			func && func(re);
		}
		App.Win.open(item);
	},
	//支付宝
	alipay:function(param,func){
		var item={name:'pay/pay_alipay',pageParam:{data:param}};
		item.func=function(ret){
			if(ret.eventType=='success')
			{
				var re={status:3,data:ret.data};
			}
			else
			{
				var re={status:1,data:'未支付'};
			}
			func && func(re);
		}
		App.Win.open(item);
	}
}