/*
	安全
*/
Plug.safe={
	key:'irm2018',
	/**加密
	 *  
	 * @access    public 系统函数 md5  base64
	 * @param     string  txt  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	lock:function(txt,key){
		if(!key || key.length<5)
		{
			key=this.key;
		}
		var signature = api.require('signature');
		var sl=7;
		var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
		
		txt = txt+key;
		
		var nh = parseInt(Math.random()*65);
		
		var ch = chars[nh];
		var mdKey =signature.md5Sync({data:key+ch,uppercase:false});
		var s=nh % sl;
		mdKey = mdKey.substring(s, s+s+7);
		
		txt = signature.base64Sync({data:txt,uppercase:false});

		var tmp = '';
		var j=0; var k = 0;
		for (var i=0; i <txt.length; i++)
		{
			k = k == mdKey.length ? 0 : k;
			j = (nh + chars.indexOf(txt[i]) + mdKey[k++].charCodeAt()) % 65;
			tmp += chars[j];
		}
		
		var len=Math.ceil(tmp.length/2);
		var pos=len + len % key.length;
		var str_1=tmp[pos];
		tmp=str_1 + tmp.substring(0,pos) + ch + tmp.substring(pos+1);
		return tmp;
	},
	/**解密
	 *  
	 * @access    public 系统函数 md5  base64
	 * @param     string  txt  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	unlock:function(txt,key){
		if(!key || key.length<5)
		{
			key=this.key;
		}
		var signature = api.require('signature');
		var sl=7;
		var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
		var len=Math.ceil((txt.length-1)/2);

		var pos=len + 1 + len % key.length;
		var ch=txt[pos];
		var str_1=txt[0];
		txt=txt.substring(1,pos)+str_1+txt.substring(pos+1);

		var nh =chars.indexOf(ch);
		var mdKey = signature.md5Sync({data:key+ch,uppercase:false});
		
		var start=nh % sl;
		var end=start*2+7;
		mdKey = mdKey.substring(start,end);
		
		var tmp = '';
		var j=0; var k = 0;
		for (var i=0; i <txt.length; i++)
		{
			k = k == mdKey.length ? 0 : k;
			j = chars.indexOf(txt[i]) - nh - mdKey[k++].charCodeAt();
			while (j<0) j+=65;
			tmp += chars[j];
		}
		tmp=signature.base64DecodeSync({data:tmp,uppercase:false});
		return tmp.substring(0,tmp.length-key.length);
	},
	/**数组解密
	 *  
	 * @access    public 系统函数 md5  base64
	 * @param     string  txt  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	lockArray:function(txt,key){
		if(typeof(txt)=='object') txt=JSON.stringify(txt);
		return this.lock(txt,key);
	},
	/**数组解密
	 *  
	 * @access    public 系统函数 md5  base64
	 * @param     string  txt  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	unlockArray:function(txt,key){
		var str=this.unlock(txt,key);
		if(!str) return false;
		
		try{
			ret=JSON.parse(str);
			return ret;
		}
		catch(err)
		{
			Log.system(txt+'解码错误'+JSON.stringify(err),8);
			return false;
	　　}
		finally
		{
	　　 　　//document.writeln("开始执行finally块语句")
		}
	}
}