/*
	幻灯
*/
Plug.slides={
	/**打开幻灯片
	 *  
	 * @access    public 打开幻灯片
	 * @param     string  para  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	open:function(para,fun){
		
		/*左右移动*/
		function irmRoll(param,func){
			param=param || {};

			func=func || function(ret){};//回调函数
			
			var containerid=param.containerid || 'slides';
			var container=$('#'+containerid);
			if(container.length==0)
			{
				func && func({status:false,msg:'容器不存在'});
				return;
			}
			
			if(Object.prototype.toString.call(param.data)!='[object Array]')
			{
				func && func({status:false,msg:'数据不存在'});
				return;
			}
			
			var box_lists=param.data || [];//数据
			var box_index=param.index || 0;//当前展示id			
			
			var rect=param.rect || {};
			var box_width=rect.w || container.width();//宽度
			var box_height=rect.h || container.height() || 'auto';//高度
			
			//容器框架1
			var obj=document.createElement("div");
			$(obj).attr('style','position:relative;overflow:hidden;');
			$(obj).width(box_width);
			$(obj).height(box_height);
			container.html(obj);
			
			var isnav=(param.isnav==undefined ? false : param.isnav);//是否展示导航

			//移动配置
			this.dis=param.dis || 20;//每次移动的距离
			
			var interval=(param.interval==undefined ? 3 : param.interval);//自动轮换间隔时间
			//窗体高度
			var win_height=param.win_height || api.winHeight;
			
			var movedis=0;//移动距离
			
			//创建移动框架
			var datatype=param.datatype || '';//数据类型
			var box=document.createElement("div");
			var Tbox=$(box);
			Tbox.attr('style','display: -webkit-box;display: -webkit-flex;display: flex;padding:0px '+box_width+'px;left:-'+box_width+'px;');
			Tbox.css('position','relative');
			var tbox_width=0;
			$(obj).html(box);
			
			//载入模块
			this.box_load=function(){
				Plug.open('image',function(){
					tbox_width=box_width*(box_lists.length);
					Tbox.width(tbox_width);
					Tbox.html('');
					//添加移动内容
					for(var i=0;i<box_lists.length;i++)
					{
						var son=document.createElement("div");
						$(son).attr('dataindex',i);
						$(son).attr('style','width:'+box_width+'px;overflow:scroll;');
						if(datatype=='image')
						{
							var str='<img data_src="'+box_lists[i]+'" src="'+Plug.image.loadimage+'" style="width:'+box_width+'px;height:'+box_height+'px;">';
						}
						else
						{
							var str=box_lists[i];
						}
						str='<div>'+str+'</div>';
						$(son).html(str);
						Tbox.append(son);
					}
					Plug.image.cache.container(box,false);
					Tbox.children().click(function(){
						box_index=$(this).index()-1;
						_this.back('click');
					})
					//载入导航
					if(isnav) _this.nav_load();
					_this.back('success');
				})
			}
			
			var son_height=0;
			//重置高度
			this.resetHeight=function(){
				var height=win_height-container.offset().top;
				if(height>200)
				{
					Tbox.children().height(height);
				}
				else
				{
					Tbox.children().css('height','auto');
				}
			}
			box.ontouchstart=function(ev){
				_this.resetHeight();
			}
			
			//导航
			
			if(isnav)
			{
				var nav=param.nav || {};
				nav.color=nav.color || '#ddd';
				nav.activecolor=nav.activecolor || '#f00';
				//导航框架
				var nav_box=document.createElement("div");
				$(nav_box).attr('style','position:absolute;width:100%;left:0px;bottom:8px;text-align:center;');
				$(obj).append(nav_box);
			}
			
			//载入导航
			this.nav_load=function(){
				if(isnav==false) return;
				$(nav_box).html('');
				//添加移动内容
				for(var i=0;i<box_lists.length;i++)
				{
					var span=document.createElement("span");
					$(span).attr('style','display:inline-block;height:7px;width:7px;margin:0px 8px;border-radius:50%;background:'+nav.color+';');
					if(i==box_index) $(span).css('background',nav.activecolor);
					$(nav_box).append(span);
				}
			}
			
			var touch_X=0;
			var touch_Y=0;
			var time_start=0;//移动时间
			var point_start=0;//位置
			var istouch=0;//手指滑动
			//开始
			obj.ontouchstart=function(ev){
				touch_X=ev.targetTouches[0].clientX;
				touch_Y=ev.targetTouches[0].clientY;
				movedis=0;
				istouch=1;
				
				var _top=ev.targetTouches[0].pageY-ev.targetTouches[0].clientY-Tbox.offset().top;
				if(_top<0) _top=0;
				Tbox.children().each(function(){
					if($(this).index()!=box_index)
					{
						$(this).css('margin-top',_top+'px');
					}
				})
			}
			//移动
			obj.ontouchmove=function(ev){
				var X_dis=ev.targetTouches[0].clientX-touch_X;
				var Y_dis=ev.targetTouches[0].clientY-touch_Y;
				touch_X=ev.targetTouches[0].clientX;
				touch_Y=ev.targetTouches[0].clientY;
				if(Math.abs(X_dis)>Math.abs(Y_dis))
				{
					if(time_start==0)
					{
						var date=new Date();
						time_start=date.getTime();
						point_start=parseFloat(Tbox.css('left'));
					}
					ev.preventDefault();
					_this.move(X_dis);
				}
				else
				{
					ev.returnValue = true;
				}
			}
			//停止
			obj.ontouchend=function(ev){
				istouch=0;
				if(time_start)
				{
					var point_end=parseFloat(Tbox.css('left'));
					var move_dis=point_end-point_start;//移动距离
					var date=new Date();
					var time_end=date.getTime();
					var move_time=time_end-time_start;//移动时间
					
					var m=-Math.ceil(point_end / box_width);
					if(m==0)
					{
						var index=0;
					}
					else if(m==box_lists.length)
					{
						var index=box_lists.length-1;
					}
					else
					{
						var index=m-1;
						var d=Math.abs(point_end % box_width);
						if(d>box_width/2)//右移
						{
							index+=1;
						}
					}
					var oldindex=box_index;
					_this.moved(index,function(ret){
						Tbox.children().each(function(){
							if($(this).index()!=oldindex)
							{
								$(this).css('margin-top','0px');
							}
						})						
						if(oldindex!=box_index && $(window).scrollTop()>Tbox.offset().top)
						{
							$(window).scrollTop(Tbox.offset().top);
						}

					});
				}
				time_start=0;
				point_start=0;
				ev.returnValue = true;
			}
			
			//移动
			this.set=function(index){
				if(movedis>0) return;//正在移动中...
				if(index==box_index) return;//等于当前id
				
				var _top=$(window).scrollTop()-Tbox.offset().top;
				if(_top<0) _top=0;
				Tbox.children().each(function(){
					if($(this).index()!=box_index)
					{
						$(this).css('margin-top',_top+'px');
					}
				})
				
				movedis=10;
				this.moved(index);
			}
			
			//移动
			this.moved=function(index,func){
				var point_end=parseFloat(Tbox.css('left'));
				
				var _left=-(index+1)*box_width;
				var time=Math.abs(parseFloat(Tbox.css('left'))-_left)*200/box_width;
				if(time<100) time=100;

				Tbox.animate({left:_left+'px'},time,function(){
					movedis=0;
					func && func();
					if(box_index!=index)
					{
						box_index=index;
						_this.back('show');						
					}
				});
			}
			//移动
			this.move=function(dis){
				var left=parseFloat(Tbox.css('left'));
				if(left>-box_width)
				{
					dis=-dis*left/box_width/2;
				}
				else if(tbox_width+left<0)
				{
					dis=dis*(left+tbox_width+box_width)/box_width/2;
				}
				left+=dis;
				Tbox.css('left',left+'px');
				return left;
			}
			//回调
			this.back=function(type){
				var ret={status:true};
				ret.type=type;
				switch(type)
				{
					case 'show':
						var index=box_index;
						ret.index=index;
						
						//导航展示
						if(isnav)
						{
							$(nav_box).children().css('background',nav.color);
							$(nav_box).children('span').eq(box_index).css('background',nav.activecolor);							
						}
						
					break;
					case 'click':
						var index=box_index;
						ret.index=index;
					break;
				}
				func && func(ret);
			}
			//添加数据
			this.addData=function(item,type){
				if(type=='prepend')
				{
					box_lists.unshift(item);
				}
				else
				{
					box_lists.push(item);
					
				}
				//载入模块
				this.box_load();
			}
			//重置数据
			this.setData=function(data){
				box_lists=data;
				//载入模块
				this.box_load();
			}
			//添加数据
			this.delData=function(index){
				box_lists.splice(index,1);
				this.box_load();
			}
			//关闭
			this.close=function(){
				clearInterval(this.intval_t);
				container.html('');
			}
			var _this=this;
			//载入模块
			this.box_load();
			this.set(box_index);
		}
		return new irmRoll(para,fun);
	}
}