/*
	幻灯 采用 inline-block
*/
Plug.slides2={
	/**打开幻灯片
	 *  
	 * @access    public 打开幻灯片
	 * @param     string  para  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	open:function(param,func){
		/*左右移动*/
		function irmRoll(){
			param=param || {};
			
			func=func || function(ret){};//回调函数
			
			var containerid=param.containerid || 'slide';
			var rootdiv=document.getElementById(containerid);
			
			var container=$(rootdiv);
			if(container.length==0)
			{
				func && func({status:false,msg:'容器不存在'});
				return;
			}
			
			var box_lists=param.data || [];//数据
			var box_index=param.index || 0;//当前展示id			
			
			var rect=param.rect || {};
			var box_width=rect.w || container.width();//宽度
			
			//容器框架1
			var obj=document.createElement("div");
			$(obj).attr('style','position:relative;overflow:hidden;');
			$(obj).width(box_width);
			container.after(obj);
			
			var isnav=param.isnav || false;//是否展示导航
			var isautoplay=param.isautoplay || false;//是否自动播放
			
			//移动配置
			this.dis=param.dis || 20;//每次移动的距离
			var interval=param.interval || 3;//自动轮换间隔时间
			
			var movedis=0;//移动距离
			
			//创建移动框架
			var datatype=param.datatype || '';//数据类型
			var box=document.createElement("div");
			var Tbox=$(box);
			Tbox.css('position','relative');
			Tbox.css('left','-'+box_width+'px');
			Tbox.css('overflow','hidden');
			$(obj).html(box);
			
			var min_height=container.height();

			//载入模块
			this.box_load=function(){
				var len=container.children().length+2;
				
				Tbox.width(box_width*len);
				
				for(var i=0;i<len;i++)
				{
					var o=document.createElement("div");
					$(o).width(box_width);
					//$(o).css('display','inline-block');
					$(o).css('overflow','hidden');
					$(o).css('min-height','1px');
					$(o).css('float','left');
					Tbox.append(o);
				}
				
				for(var i=0;i<len;i++)
				{
					if(i==0)
					{
						var o=container.children().eq(len-3).clone();
					}
					else if(i==len-1)
					{
						var o=container.children().eq(0).clone();
					}
					else
					{
						var o=container.children().eq(i-1).clone();
					}
					Tbox.children().eq(i).html(o);
					min_height=Math.min(min_height,Tbox.children().eq(i).height());
				}
				container.html('');
				Tbox.children().click(function(){
					box_index=$(this).index()-1;
					_this.back('click');
				})
				//载入导航
				if(isnav) _this.nav_load();
				//加载成功回调
				_this.back('success');
				_this.set(box_index);
				
				
				document.addEventListener('scroll',function(ev){
					var index_1=box_index+1>=Tbox.children().length ? 0 :box_index+1;
					var o=Tbox.children().eq(index_1);
					var h=o.height();
					var _top=container.offset().top+h;
					
					var d=_top-$(window).scrollTop()-$(window).height();
					if(d<50)
					{
						Tbox.height(h);
						setTimeout(function(){
							Tbox.height('auto');
						},200)
					}
				},false);
			}
			
			//导航
			
			if(isnav)
			{
				var nav=param.nav || {};
				nav.color=nav.color || '#ddd';
				nav.activecolor=nav.activecolor || '#f00';
				//导航框架
				var nav_box=document.createElement("div");
				$(nav_box).attr('style','position:absolute;width:100%;left:0px;bottom:8px;text-align:center;');
				$(obj).append(nav_box);
			}
			
			//载入导航
			this.nav_load=function(){
				if(isnav==false) return;
				$(nav_box).html('');
				//添加移动内容
				for(var i=0;i<box_lists.length;i++)
				{
					var span=document.createElement("span");
					$(span).attr('style','display:inline-block;height:7px;width:7px;margin:0px 8px;border-radius:50%;background:'+nav.color+';');
					if(i==box_index) $(span).css('background',nav.activecolor);
					$(nav_box).append(span);
				}
			}
			
			var touch_X=0;
			var touch_Y=0;
			var time_start=0;//移动时间
			var point_start=0;//位置
			var istouch=0;//手指滑动
			//开始
			obj.ontouchstart=function(ev){
				//ev.preventDefault();
				touch_X=ev.targetTouches[0].clientX;
				touch_Y=ev.targetTouches[0].clientY;
				movedis=0;
				istouch=1;
				
				var Tboxlen=Tbox.children().length;
				
				Tbox.children(':first').html(Tbox.children().eq(Tboxlen-2).html());
				Tbox.children(':last').html(Tbox.children().eq(1).html());
			}
			//移动
			obj.ontouchmove=function(ev){
				var X_dis=ev.targetTouches[0].clientX-touch_X;
				var Y_dis=ev.targetTouches[0].clientY-touch_Y;
				touch_X=ev.targetTouches[0].clientX;
				touch_Y=ev.targetTouches[0].clientY;
				if(Math.abs(X_dis)>Math.abs(Y_dis))
				{
					if(time_start==0)
					{
						var date=new Date();
						time_start=date.getTime();
						point_start=parseFloat(Tbox.css('left'));
					}
					ev.preventDefault();
					_this.move(X_dis);
				}
				else
				{
					ev.returnValue = true;
				}
			}
			//停止
			obj.ontouchend=function(ev){
				Tbox.children(':first').html('');
				Tbox.children(':last').html('');
				
				istouch=0;
				if(time_start)
				{
					var point_end=parseFloat(Tbox.css('left'));
					var move_dis=point_end-point_start;//移动距离
					var date=new Date();
					var time_end=date.getTime();
					var move_time=time_end-time_start;//移动时间
					var move_v=Math.abs(move_dis / move_time);//移动速度

					var lw=Tbox.width();//整体宽度
					var w=$(obj).width();//块宽度
					var d=Math.abs(point_end % w);
					
					if(move_dis>0)//右移
					{
						dis_f=d;
						dis_b=w-dis_f;
						var type=1;
					}
					else//左移
					{
						var dis_b=d;
						var dis_f=w-dis_b;
						var type=-1;
					}
					
					//移动距离超过一半
					if(dis_f<w/2)
					{
						movedis=dis_f;
						_this.moved(type);
						return;
					}
					
					//剩余部分按当前速度 需要的时间
					var t=dis_f/move_v;

					//继续移动
					if(t<500)
					{
						movedis=dis_f;
						_this.moved(type);
					}
					else//返回
					{
						movedis=dis_b;
						_this.moved(-type);
					}
				}
				time_start=0;
				point_start=0;
				ev.returnValue = true;
			}
			
			//移动
			this.set=function(index){
				if(movedis>0) return;//正在移动中...
				if(index==box_index) return;//等于当前id
				movedis=box_width*Math.abs(index-box_index);
				var type=1;
				if(index>box_index) type=-1;
				this.moved(type);
			}
			
			//移动
			this.moved=function(type){
				var dis=Math.min(movedis,_this.dis);
				movedis-=dis;
				var left=this.move(dis*type);
				if(movedis>0)
				{
					setTimeout(function(){
						_this.moved(type);
					},10)
				}
				else
				{
					if(left==0)
					{
						var left=(box_width*2-Tbox.width());
						Tbox.css('left',left+'px');
						box_index=box_lists.length-1;
					}
					else if(Tbox.width()+left==box_width)
					{
						left=-box_width;
						Tbox.css('left',left+'px');
						box_index=0;
					}
					else
					{
						box_index=-parseInt(left/box_width)-1;
					}
					
					//导航展示
					if(isnav)
					{
						$(nav_box).children().css('background',nav.color);
						$(nav_box).children('span').eq(box_index).css('background',nav.activecolor);							
					}
				
					this.back('show');
				}
			}
			//移动
			this.move=function(dis){
				var left=parseFloat(Tbox.css('left'));
				left+=dis;
				Tbox.css('left',left+'px');
				return left;
			}
			//回调
			this.back=function(type){
				var ret={status:true,index:box_index};
				ret.type=type;
				switch(type)
				{
					case 'show':
						var index_1=box_index+1>=Tbox.children().length ? 0 :box_index+1;
						var o=Tbox.children().eq(index_1);
						var h=o.height();
						var _t=container.offset().top;
						var d=h+_t-$(window).scrollTop()-$(window).height();
						if(d<0) $(window).scrollTop(_t);
					break;
					case 'click':
					break;
				}
				func && func(ret);
			}
			//添加数据
			this.addData=function(item,type){
				if(type=='prepend')
				{
					box_lists.unshift(item);
				}
				else
				{
					box_lists.push(item);
				}
				//载入模块
				this.box_load();
			}
			//重置数据
			this.setData=function(data){
				box_lists=data;
				//载入模块
				this.box_load();
			}
			//添加数据
			this.delData=function(index){
				box_lists.splice(index,1);
				this.box_load();
			}
			//关闭
			this.close=function(){
				clearInterval(this.intval_t);
				container.html('');
			}
			var _this=this;
			//载入模块
			this.box_load();
			//自动播放
			if(isautoplay)
			{
				this.intval_t=setInterval(function(){
					if(istouch>0) return;
					
					var index=box_index+1;
					_this.set(index);
				},interval*1000)				
			}
		}
		return new irmRoll();
	}
}