/*
	模板缓存
*/
Plug.temp={
	lists:{},
	//保存配置
	save:function(config){
		App.saveconfig(config);
	},
	//缓存模板
	cache:function(config){
		var self=this;
		var fs = api.require('fs');
		//复制模板到缓存
		var copy=function(){
			var newPath=Config.cachedir;
			//苹果手机
			if(api.systemType=='ios') newPath='fs://';
			
			var fs = api.require('fs');
			fs.copyTo({
				oldPath:Config.localdir,
				newPath:newPath
			}, function(ret, err){
				if (ret.status)
				{
					config.tempcache=1;
					self.save(config);
					self.update.reset(function(){
						self.update.init();
					})
					Log.debug(url+'本地模板复制缓存模板成功');
				}
				else
				{
					//本地模板复制缓存模板失败
					Log.system(Config.localdir+'本地模板复制缓存模板失败'+newPath+JSON.stringify(err),3);
				}
			});
		}
		//检测缓存模板是否存在
		var check=function(){
			fs.readDir({
				path:Config.cachedir
			}, function(ret, err){
				if (ret.status)
				{
					config.tempcache=1;
					self.save(config);
					self.update.init();
				}
				else
				{
					copy(config);
				}
			});
		}
		check();
	},
	//更新模板
	update:{
		key:'versionautoupdate',
		cachePath:'fs://xzztemp/widget/',
		//初始化数据库
		init:function(){
			var self=this;
			Plus_jsoncache.getcache(this.key,function(ret){
				if(ret.status)
				{
					//如果正在下载模板 继续下载
					if(ret.data.type)
					{
						if(ret.data.type=='down')
						{
							self.down(ret.data);
						}
						else if(ret.data.type=='copy')
						{
							self.copy(ret.data);
						}
						else if(ret.data.type=='finish')
						{
							self.finish(ret.data);
						}
					}
					else
					{
						//检测模板是否更新
						self.check(ret.data.temptime);
					}
				}
				else
				{
					self.check(Config.temptime);
				}
			})
		},
		//检测是否更新
		check:function(temptime){
			var self=this;
			App.getconfig(function(ret){
				//服务器时间大于客户端时间 模板更新
				if(ret.temptime>temptime)
				{
					self.get(temptime,ret.temptime);
				}
			});
		},
		//获取更新模板列表
		get:function(temptime,endtime){
			var self=this;
			var item={view:'temp',appid:Config.c,cm:'gettemp',starttime:temptime};
			safeData(item,function(ret){
				if(ret.status==3)
				{
					var param={temptime:temptime,endtime:endtime,type:'down',lists:ret.data,index:0};
					self.set(param);
					self.down(param);
				}
				else
				{
					Log.system('获取更新模板列表失败',3);
				}
			})
		},
		//保存配置
		set:function(param){
			Plus_jsoncache.cache(this.key,param);
		},
		//重置参数
		reset:function(func){
			var self=this;
			Plus_jsoncache.drop(this.key,function(){
				var fs = api.require('fs');
				fs.rmdir({
					path:self.cachePath
				}, function(ret, err){
					if(typeof(func)=='function') func && func();
				});
			});
		},
		//下载模板
		down:function(param){
			var self=this;
			var fallnum=0;//下载失败次数
			var index=param.index || 0;
			var startdown=function(){
				var path=param.lists[index];
				//下载完毕
				if(!path)
				{
					param.type='copy';
					param.index=0;
					self.set(param);
					self.copy(param);
					return;
				}
				if(path.substr(0,1)=='/') path=path.substr(1);
				var savepath=self.cachePath+path;
				var item={view:'temp',appid:Config.c,cm:'down',file:path};
				getData(item,function(ret){
					if(ret.status==3)
					{
						api.writeFile({
							path: savepath,
							data:ret.data
						}, function(ret, err){
							if(ret.status)
							{
								
							}
							else
							{
								ret.err=err;
								Log.system('保存模板失败'+JSON.stringify(err),3);
							}
						});
					}
					else
					{
						Log.system('获取更新模板列表失败'+JSON.stringify(item),3);
					}
					param.index=index;
					self.set(param);
					index++;
					startdown();
				})
			}
			startdown();
		},
		//复制更新模板
		copy:function(param){
			var self=this;
			var fallnum=0;//复制失败次数
			var fs = api.require('fs');
			var index=param.index || 0;
			//删除指定文件
			var fremove=function(file,func){
				fs.remove({
					path:file
				}, function(ret, err){
					if (ret.status)
					{
						//alert(JSON.stringify(ret));
					} 
					else
					{
						//alert(JSON.stringify(err));
					}
					if(typeof(func)=='function') func && func();
				});
			}
			//复制指定文件
			var fcopy=function(){
				var path=param.lists[index];
				//下载完毕
				if(!path)
				{
					param.type='finish';
					self.finish(param);
					return;
				}
				if(path.substr(0,1)=='/') path=path.substr(1);
				var newFile=Config.cachedir+path;
				var newpath=newFile.substr(0,newFile.lastIndexOf('/'));
				var oldFile=self.cachePath+path;

				fremove(newFile,function(){
					fs.copyTo({
						oldPath:oldFile,
						newPath:newpath
					}, function(ret, err){
						if (!ret.status)
						{
							Log.system(oldFile+'临时位置复制到缓存失败，'+newFile+JSON.stringify(err),3);
						}
						param.index=index;
						self.set(param);
						index++;
						fremove(oldFile);
						fcopy();//继续复制
					});
				});
			}
			fcopy();
		},
		//复制完毕
		finish:function(param){
			param.temptime=param.endtime;
			param.type='';
			param.index=0;
			param.lists=[];
			this.set(param);
			Log.system('模板更新完毕');
		}
	},
	//获取缓存
	getcache:function(file,func){
		if(this.lists[file])
		{
			func && func({status:3,data:this.lists[file]});
			return;
		}
		var self=this;
		if(file.substr(0,1)=='/') file=file.substr(1);
		var path=App.getcachefile(file);
		//异步返回结果：
		api.readFile({
			path:path
		}, function(ret, err){
			if (ret.status)
			{
				self.lists[file]=ret.data;
				func && func({status:3,data:ret.data});
			}
			else
			{
				Log.debug(path+'获取缓存模板失败'+JSON.stringify(err));
				self.getremote(file,func);
			}
		});
	},
	//获取远程模板
	getremote:function(file,func){
		var self=this;
		var name=file;
		if(file.substr(0,1)=='/') file=file.substr(1);
		var item={view:'temp',appid:Config.c,cm:'down',file:file};
		var path=App.getcachefile(file);
		getData(item,function(ret){
			if(ret.status==3)
			{
				api.writeFile({
					path: path,
					data:ret.data
				}, function(ret, err){
					if(ret.status)
					{
						
					}
					else
					{
						ret.err=err;
						Log.system(path+'保存模板失败'+JSON.stringify(err),3);
					}
				});
				self.lists[name]=ret.data;
			}
			else
			{
				Log.debug(path+'保存缓存模板失败'+JSON.stringify(err));
			}
			if(typeof(func)=='function') func(ret);
		})
	},
	//删除缓存模板
	drop:function(){
		var self=this;
		var fs = api.require('fs');
		var path=Config.cachedir;
		fs.rmdir({
			path: path
		}, function(ret, err){
			if (ret.status)
			{
				api.toast({msg:'缓存模板删除成功'});
			}
			else 
			{
				alert(JSON.stringify(err));
			}
		});
	}
}