/*
	视频播放日志
*/
Plug.videolog={
	istable:0,
	table:'video_log',
	items:{},
	//打开我的收藏
	open:function(aid){
		this.get(aid,function(ret){
			if(ret.status)
			{
				switch(parseInt(ret.data.cat))
				{
					//题库
					case 3:
						Plug.open('question',function(){
							Plug.question.book.open(ret.data.question);
						})
						return;
					break;
				}
				App.Win.open({name:Plug.kc.module+'/article',aid:aid,para:ret.data});
			}
			else
			{
				api.alert({msg:ret.data});
			}
		})
	},
	//获取内容
	get:function(aid,func){
		var self=this;
		//获取服务器数据
		var remote=function(){
			var para={view:'article',cm:'getitem',aid:aid};
			Plug.kc.getData(para,function(ret,err){
				if(ret)
				{
					func && func(ret);
					if(ret.status==3)
					{
						var item=ret.data;
						self.add(item,true);
					}
				}
				else
				{
					func && func(ret,err);
				}
			})
		}
		var item=this.getItem(aid);
		//缓存 存在
		if(item)
		{
			var date=new Date();
			var nowtime=date.getStamp();
			if(nowtime>item.cachetime)
			{
				remote();
			}
			else
			{
				func && func({status:3,data:item});
				this.add(item);
			}
		}
		else //缓存不存在 请求服务器数据
		{
			remote();
		}
	},
	//查询数据
	getItem:function(aid){
		if(this.items[aid]) return this.items[aid];
		
		var table=this.getTable();
		//不支持缓存
		if(!table) return false;
		var param={};
		param.where=[];
		param.where='aid ='+aid;
		
		var ret=Db.getItem(table,param);
		if(ret.status)
		{
			var item=JSON.parse(ret.data.body);
			item.cachetime=ret.data.cachetime;
			this.items[aid]=item;
			return item;
		}
		else
		{
			return false;
		}
	},
	//查询数据
	getLists:function(start){
		var table=this.getTable();
		//不支持缓存
		if(!table) return false;
		var param={};
		param.offset=start || 0;
		param.limit=20;
		param.order='edittime DESC';
		var ret=Db.getLists(table,param);
		if(ret.status)
		{
			var lists=[];
			for(var i=0;i<ret.data.length;i++)
			{
				lists.push(JSON.parse(ret.data[i].body));
			}
			return lists;
		}
		else
		{
			return false;
		}
	},
	//添加
	add:function(item,isnew){
		var table=this.getTable();
		//不支持缓存
		if(!table) return {status:false,msg:'表不存在'};

		var post={};
		post.aid=item.aid;
		var date=new Date();
		var nowtime=date.getStamp();
		post.edittime=nowtime;
		
		var aid=item.aid;
		
		var ret=this.getItem(aid);
		if(ret)
		{
			var ret=Db.update(table,post,'aid='+aid);
		}
		else
		{
			var ret=Db.insert(table,post);
		}
		this.items[aid]=item;
		return ret;
	},
	del:function(aid){
		var table=this.getTable();
		//不支持缓存
		if(!table) return {status:false,msg:'表不存在'};
		return Db.update(table,'aid='+aid);
	},
	drop:function(){
		var ret=Db.drop(this.table);
		api.alert({msg:ret});
	},
	getTable:function(){
		if(this.istable) return this.table;
		
		var ret=Db.isTable(this.table);
		if(ret.status)
		{
			this.istable=1;
			return this.table;
		}
		var field='aid int PRIMARY KEY,edittime int,cachetime int,type int,topid int,article int,title varchar(255)';
		var ret=Db.create(this.table,field);
		if(ret.status)
		{
			this.istable=1;
			return this.table;
		}
		return false;
	}
}