/*
	数据缓存
*/
var Plus_jsoncache={
	lists:{},
	/*
		name 数据名称
		item 请求服务器参数
		func 回调函数
		intval 检测更新间隔时间 默认 24*60*60
	*/
	read:function(name,item,func,intval,url){//初始化
		if(typeof(item)!='object') return;
		this.getcache(name,function(ret){
			if(ret.status)
			{
				var data=ret.data;
				var timestamp = Date.parse(new Date());
				var nowtime = timestamp / 1000;
				var cachetime=parseInt(data.cachetime)||0;
				intval=intval || 24*60*60;
				if(nowtime-cachetime>intval)//间隔 一定时间访问服务器检测是否更新
				{
					item.time=data.time;
					data.cachetime=nowtime;
				}
				else
				{
					if(typeof(func)=='function')
					{
						func && func(3,data.lists);
					}
					return;
				}
			}
			else
			{
				item.time=0;
			}
			Plus_jsoncache.get(name,item,func,data,url);
		})
	},
	get:function(name,item,func,data,url){//远程服务器获取数据
		getData(item,function(ret){
			if(ret.status==3)//数据已经更新
			{
				Plus_jsoncache.cache(name,ret.data);
				if(typeof(func)=='function')
				{
					var lists=ret.data.lists;
					func && func(3,lists);
				}
			}
			else if(ret.status==2)//未更新
			{
				Plus_jsoncache.cache(name,data);
				if(typeof(func)=='function')
				{
					var lists=data.lists;
					func && func(3,lists);
				}
			}
			else//请求失败
			{
				if(typeof(func)=='function')
				{
					func && func(1,'内容为空11');
				}
			}
		},'',url)
	},
	/*保存数据
		name string 名称
		data object 保存对象
		func  function 回调函数
	*/
	cache:function(name,data,func){
		if(typeof(data)!='object') return;
		var timestamp = Date.parse(new Date());
		data.cachetime = timestamp / 1000;
		Plus_jsoncache.lists[name]=data;
		var cachefile='fs://'+name+'.json';
		api.writeFile({
			path: cachefile,
			data: $api.jsonToStr(data)
		}, function(ret, err){
			if(typeof(func)=='function')
			{
				func && func(ret,err);
			}
		});
	},
	/*获取缓存数据
		name string 名称
		data object 保存对象
		func  function 回调函数
	*/
	getcache:function(name,func){
		if(typeof(this.lists[name])!='undefined')//已经检测缓存
		{
			if(this.lists[name])//缓存数据存在
			{
				var ret={status:true,data:this.lists[name]};
			}
			else//缓存数据不存在
			{
				var ret={status:false,data:'缓存数据在'};
			}
			if(typeof(func)=='function')
			{
				func && func(ret);
			}
			return;
		}
		var cachefile=this.getcachefile(name);
		//异步返回结果：
		api.readFile({
			path: cachefile
		}, function(ret, err){
			if (ret.status)
			{
				try{
					var data=$api.strToJson(ret.data);
					Plus_jsoncache.lists[name]=data;
					var ret={status:true,data:data};
				}
				catch(err)
				{
					var ret={status:false,data:err};
			　　}
				finally
				{
			　　 　　//document.writeln("开始执行finally块语句")
			　　}
			}
			else
			{
				var ret={status:false,data:err};
			}
			if(typeof(func)=='function')
			{
				func && func(ret);
			}
		})
	},
	/*获取保存数据路径
		name string 名称
		return string
	*/
	getcachefile:function(name){
		var file='fs://'+name+'.json';
		return file;
	}
}