/*
	幻灯
*/
slide_a={
	/**打开幻灯片
	 *  
	 * @access    public 打开幻灯片
	 * @param     string  para  字符串
	 * @param     string  key  加密key
	 * @return    string
	 */
	open:function(param,func){
		/*左右移动*/
		function irmRoll(){
			var index=param.index || 0;//默认键值
			
			//移动配置
			var dis=param.dis || 20;//每次移动的距离
			var interval=param.interval || 0;//自动轮换间隔时间
			
			var movedis=0;//移动距离
			var height=param.height || 500;
			
			var containerid=param.containerid || 'slide';//容器id
			var lists=param.data || [];//数据
			var box=$('#'+containerid);
			
			var box_w=box.width();
			box.attr('style','position:relative;width:'+box_w+'px;height:'+height+'px;overflow:hidden;');
			
			var touch_X=0;
			var touch_Y=0;
			var istouch=0;//手指滑动
			var movedis=0;
			
			//初始化
			this.init=function(){
				if(lists.length>0)
				{
					this.setData(lists);
				}
				else
				{
					box.children().each(function(){
						_this.loadSon(this);
					})
					
				}
			}
			
			//添加数据
			this.addData=function(obj,type){
				var div=document.createElement("div");
				$(div).html(obj);
				if(type=='prepend')
				{
					box.prepend(div);
				}
				else
				{
					box.append(div);
				}
				this.loadSon(div);
			}
			//重置数据
			this.setData=function(data){
				$(box).html('');
				for(var i=0;i<data.length;i++)
				{
					this.addData(data[i]);			
				}
			}
			//添加数据
			this.delData=function(i){
				box.children().eq(i).remove();
			}
			
			//触摸事件
			this.loadSon=function(d){
				var i=$(d).index();
				var l=i==index ? 0 : box_w;
				$(d).attr('style','position:absolute;width:'+box_w+'px;height:'+height+'px;top:0px;left:'+l+'px;overflow-y:scroll;');
				
				//开始
				d.ontouchstart=function(ev){
					//ev.preventDefault();
					touch_X=ev.targetTouches[0].clientX;
					touch_Y=ev.targetTouches[0].clientY;
					movedis=0;
					istouch=1;
				}
				
				//移动
				d.ontouchmove=function(ev){
					var X_dis=ev.targetTouches[0].clientX-touch_X;
					var Y_dis=ev.targetTouches[0].clientY-touch_Y;
					
					touch_X=ev.targetTouches[0].clientX;
					touch_Y=ev.targetTouches[0].clientY;
					if(Math.abs(X_dis)>Math.abs(Y_dis))
					{
						ev.preventDefault();
						_this.move(X_dis);
					}
					else
					{
						ev.returnValue = true;
					}
				}
				//停止
				d.ontouchend=function(ev){
					istouch=0;
					var left=parseFloat(box.children().eq(index).css('left'));
					if(left>=0)
					{
						if(left>box_w/2)
						{
							var type=1;
							movedis=box_w-left;
						}
						else
						{
							var type=-1;
							movedis=left;
						}
						_this.moved(type);
					}
					else
					{
						if(left+box_w/2<0)
						{
							var type=-1;
							movedis=box_w+left;
						}
						else
						{
							var type=1;
							movedis=-left;
						}
						_this.moved(type);
					}
					ev.returnValue = true;
				}
				//点击事件
				d.onclick=function(){
					_this.back('click');
				}
			}
			//移动
			this.move=function(d){
				var left=parseFloat(box.children().eq(index).css('left'));
				left+=d;
				
				box.children().eq(index).css('left',left+'px');
				if(left>0)
				{
					var pi=index==0 ? box.children().length-1:index-1;
					var pl=left-box_w;
					box.children().eq(pi).css('left',pl+'px');
					if(left>=box_w)
					{
						index=pi;
						this.back('show');
					}
				}
				else
				{
					var ni=index+1==box.children().length ? 0:index+1;
					var nl=left+box_w;
					box.children().eq(ni).css('left',nl+'px');
					if(left+box_w<=0)
					{
						index=ni;
						this.back('show');
					}
				}
				return left;
			}
			
			//移动
			this.moved=function(type){
				var d=Math.min(movedis,dis);
				movedis-=d;
				this.move(d*type);
				if(movedis>0)
				{
					setTimeout(function(){
						_this.moved(type);
					},10)
				}
			}
			
			//移动
			this.set=function(i){
				if(movedis>0) return;//正在移动中...
				if(i==index) return;//等于当前id
				movedis=box_w*Math.abs(i-index);
				var type=1;
				if(i>index) type=-1;
				this.moved(type);
			}

			//回调
			this.back=function(type){
				var ret={status:true};
				ret.type=type;
				ret.index=index;
				func && func(ret);
			}
			
			var ntval_t=0;
			//关闭
			this.close=function(){
				clearInterval(ntval_t);
				box.html('');
			}
			var _this=this;
			this.init();
			this.back('success');

			//自动播放
			if(interval)
			{
				ntval_t=setInterval(function(){
					if(istouch>0) return;
					var i=index==box.children().length ? 0 : index+1;
					_this.set(i);
				},interval*1000)				
			}
		}
		return new irmRoll();
	}
}